// Compiled by ClojureScript 1.9.229 {:static-fns true, :optimize-constants true}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var args42169 = [];
var len__10461__auto___42175 = arguments.length;
var i__10462__auto___42176 = (0);
while(true){
if((i__10462__auto___42176 < len__10461__auto___42175)){
args42169.push((arguments[i__10462__auto___42176]));

var G__42177 = (i__10462__auto___42176 + (1));
i__10462__auto___42176 = G__42177;
continue;
} else {
}
break;
}

var G__42171 = args42169.length;
switch (G__42171) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42169.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async42172 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async42172 = (function (f,blockable,meta42173){
this.f = f;
this.blockable = blockable;
this.meta42173 = meta42173;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async42172.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_42174,meta42173__$1){
var self__ = this;
var _42174__$1 = this;
return (new cljs.core.async.t_cljs$core$async42172(self__.f,self__.blockable,meta42173__$1));
});

cljs.core.async.t_cljs$core$async42172.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_42174){
var self__ = this;
var _42174__$1 = this;
return self__.meta42173;
});

cljs.core.async.t_cljs$core$async42172.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async42172.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async42172.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async42172.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async42172.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$blockable,cljs.core.cst$sym$meta42173], null);
});

cljs.core.async.t_cljs$core$async42172.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async42172.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async42172";

cljs.core.async.t_cljs$core$async42172.cljs$lang$ctorPrWriter = (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async42172");
});

cljs.core.async.__GT_t_cljs$core$async42172 = (function cljs$core$async$__GT_t_cljs$core$async42172(f__$1,blockable__$1,meta42173){
return (new cljs.core.async.t_cljs$core$async42172(f__$1,blockable__$1,meta42173));
});

}

return (new cljs.core.async.t_cljs$core$async42172(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || (buff.cljs$core$async$impl$protocols$UnblockingBuffer$)){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args42181 = [];
var len__10461__auto___42184 = arguments.length;
var i__10462__auto___42185 = (0);
while(true){
if((i__10462__auto___42185 < len__10461__auto___42184)){
args42181.push((arguments[i__10462__auto___42185]));

var G__42186 = (i__10462__auto___42185 + (1));
i__10462__auto___42185 = G__42186;
continue;
} else {
}
break;
}

var G__42183 = args42181.length;
switch (G__42183) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42181.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str("buf-or-n")].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var args42188 = [];
var len__10461__auto___42191 = arguments.length;
var i__10462__auto___42192 = (0);
while(true){
if((i__10462__auto___42192 < len__10461__auto___42191)){
args42188.push((arguments[i__10462__auto___42192]));

var G__42193 = (i__10462__auto___42192 + (1));
i__10462__auto___42192 = G__42193;
continue;
} else {
}
break;
}

var G__42190 = args42188.length;
switch (G__42190) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42188.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2(xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(cljs.core.async.impl.buffers.promise_buffer(),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args42195 = [];
var len__10461__auto___42198 = arguments.length;
var i__10462__auto___42199 = (0);
while(true){
if((i__10462__auto___42199 < len__10461__auto___42198)){
args42195.push((arguments[i__10462__auto___42199]));

var G__42200 = (i__10462__auto___42199 + (1));
i__10462__auto___42199 = G__42200;
continue;
} else {
}
break;
}

var G__42197 = args42195.length;
switch (G__42197) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42195.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(ret)){
var val_42202 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_42202) : fn1.call(null,val_42202));
} else {
cljs.core.async.impl.dispatch.run(((function (val_42202,ret){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_42202) : fn1.call(null,val_42202));
});})(val_42202,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args42203 = [];
var len__10461__auto___42206 = arguments.length;
var i__10462__auto___42207 = (0);
while(true){
if((i__10462__auto___42207 < len__10461__auto___42206)){
args42203.push((arguments[i__10462__auto___42207]));

var G__42208 = (i__10462__auto___42207 + (1));
i__10462__auto___42207 = G__42208;
continue;
} else {
}
break;
}

var G__42205 = args42203.length;
switch (G__42205) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42203.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__6726__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__6726__auto__)){
var ret = temp__6726__auto__;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__6726__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(temp__6726__auto__)){
var retb = temp__6726__auto__;
var ret = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(retb) : cljs.core.deref.call(null,retb));
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
} else {
cljs.core.async.impl.dispatch.run(((function (ret,retb,temp__6726__auto__){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
});})(ret,retb,temp__6726__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__10291__auto___42210 = n;
var x_42211 = (0);
while(true){
if((x_42211 < n__10291__auto___42210)){
(a[x_42211] = (0));

var G__42212 = (x_42211 + (1));
x_42211 = G__42212;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(i,n)){
return a;
} else {
var j = cljs.core.rand_int(i);
(a[i] = (a[j]));

(a[j] = i);

var G__42213 = (i + (1));
i = G__42213;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true) : cljs.core.atom.call(null,true));
if(typeof cljs.core.async.t_cljs$core$async42217 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async42217 = (function (alt_flag,flag,meta42218){
this.alt_flag = alt_flag;
this.flag = flag;
this.meta42218 = meta42218;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async42217.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_42219,meta42218__$1){
var self__ = this;
var _42219__$1 = this;
return (new cljs.core.async.t_cljs$core$async42217(self__.alt_flag,self__.flag,meta42218__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async42217.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_42219){
var self__ = this;
var _42219__$1 = this;
return self__.meta42218;
});})(flag))
;

cljs.core.async.t_cljs$core$async42217.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async42217.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(self__.flag) : cljs.core.deref.call(null,self__.flag));
});})(flag))
;

cljs.core.async.t_cljs$core$async42217.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async42217.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(self__.flag,null) : cljs.core.reset_BANG_.call(null,self__.flag,null));

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async42217.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$alt_DASH_flag,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(cljs.core.PersistentVector.EMPTY))], null)),cljs.core.cst$sym$flag,cljs.core.cst$sym$meta42218], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async42217.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async42217.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async42217";

cljs.core.async.t_cljs$core$async42217.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async42217");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async42217 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async42217(alt_flag__$1,flag__$1,meta42218){
return (new cljs.core.async.t_cljs$core$async42217(alt_flag__$1,flag__$1,meta42218));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async42217(cljs$core$async$alt_flag,flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async42223 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async42223 = (function (alt_handler,flag,cb,meta42224){
this.alt_handler = alt_handler;
this.flag = flag;
this.cb = cb;
this.meta42224 = meta42224;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async42223.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_42225,meta42224__$1){
var self__ = this;
var _42225__$1 = this;
return (new cljs.core.async.t_cljs$core$async42223(self__.alt_handler,self__.flag,self__.cb,meta42224__$1));
});

cljs.core.async.t_cljs$core$async42223.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_42225){
var self__ = this;
var _42225__$1 = this;
return self__.meta42224;
});

cljs.core.async.t_cljs$core$async42223.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async42223.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
});

cljs.core.async.t_cljs$core$async42223.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async42223.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async42223.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$alt_DASH_handler,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$private,true,cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$flag,cljs.core.cst$sym$cb], null)))], null)),cljs.core.cst$sym$flag,cljs.core.cst$sym$cb,cljs.core.cst$sym$meta42224], null);
});

cljs.core.async.t_cljs$core$async42223.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async42223.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async42223";

cljs.core.async.t_cljs$core$async42223.cljs$lang$ctorPrWriter = (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async42223");
});

cljs.core.async.__GT_t_cljs$core$async42223 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async42223(alt_handler__$1,flag__$1,cb__$1,meta42224){
return (new cljs.core.async.t_cljs$core$async42223(alt_handler__$1,flag__$1,cb__$1,meta42224));
});

}

return (new cljs.core.async.t_cljs$core$async42223(cljs$core$async$alt_handler,flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = cljs.core.cst$kw$priority.cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((0)) : port.call(null,(0))):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((1)) : port.call(null,(1)));
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__42226_SHARP_){
var G__42230 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__42226_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__42230) : fret.call(null,G__42230));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__42227_SHARP_){
var G__42231 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__42227_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__42231) : fret.call(null,G__42231));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(vbox) : cljs.core.deref.call(null,vbox)),(function (){var or__9278__auto__ = wport;
if(cljs.core.truth_(or__9278__auto__)){
return or__9278__auto__;
} else {
return port;
}
})()], null));
} else {
var G__42232 = (i + (1));
i = G__42232;
continue;
}
} else {
return null;
}
break;
}
})();
var or__9278__auto__ = ret;
if(cljs.core.truth_(or__9278__auto__)){
return or__9278__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,cljs.core.cst$kw$default)){
var temp__6728__auto__ = (function (){var and__9266__auto__ = cljs.core.async.impl.protocols.active_QMARK_(flag);
if(cljs.core.truth_(and__9266__auto__)){
return cljs.core.async.impl.protocols.commit(flag);
} else {
return and__9266__auto__;
}
})();
if(cljs.core.truth_(temp__6728__auto__)){
var got = temp__6728__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$default.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$default], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__10468__auto__ = [];
var len__10461__auto___42238 = arguments.length;
var i__10462__auto___42239 = (0);
while(true){
if((i__10462__auto___42239 < len__10461__auto___42238)){
args__10468__auto__.push((arguments[i__10462__auto___42239]));

var G__42240 = (i__10462__auto___42239 + (1));
i__10462__auto___42239 = G__42240;
continue;
} else {
}
break;
}

var argseq__10469__auto__ = ((((1) < args__10468__auto__.length))?(new cljs.core.IndexedSeq(args__10468__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__10469__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__42235){
var map__42236 = p__42235;
var map__42236__$1 = ((((!((map__42236 == null)))?((((map__42236.cljs$lang$protocol_mask$partition0$ & (64))) || (map__42236.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__42236):map__42236);
var opts = map__42236__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq42233){
var G__42234 = cljs.core.first(seq42233);
var seq42233__$1 = cljs.core.next(seq42233);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__42234,seq42233__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args42241 = [];
var len__10461__auto___42291 = arguments.length;
var i__10462__auto___42292 = (0);
while(true){
if((i__10462__auto___42292 < len__10461__auto___42291)){
args42241.push((arguments[i__10462__auto___42292]));

var G__42293 = (i__10462__auto___42292 + (1));
i__10462__auto___42292 = G__42293;
continue;
} else {
}
break;
}

var G__42243 = args42241.length;
switch (G__42243) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42241.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__42110__auto___42295 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___42295){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___42295){
return (function (state_42267){
var state_val_42268 = (state_42267[(1)]);
if((state_val_42268 === (7))){
var inst_42263 = (state_42267[(2)]);
var state_42267__$1 = state_42267;
var statearr_42269_42296 = state_42267__$1;
(statearr_42269_42296[(2)] = inst_42263);

(statearr_42269_42296[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (1))){
var state_42267__$1 = state_42267;
var statearr_42270_42297 = state_42267__$1;
(statearr_42270_42297[(2)] = null);

(statearr_42270_42297[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (4))){
var inst_42246 = (state_42267[(7)]);
var inst_42246__$1 = (state_42267[(2)]);
var inst_42247 = (inst_42246__$1 == null);
var state_42267__$1 = (function (){var statearr_42271 = state_42267;
(statearr_42271[(7)] = inst_42246__$1);

return statearr_42271;
})();
if(cljs.core.truth_(inst_42247)){
var statearr_42272_42298 = state_42267__$1;
(statearr_42272_42298[(1)] = (5));

} else {
var statearr_42273_42299 = state_42267__$1;
(statearr_42273_42299[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (13))){
var state_42267__$1 = state_42267;
var statearr_42274_42300 = state_42267__$1;
(statearr_42274_42300[(2)] = null);

(statearr_42274_42300[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (6))){
var inst_42246 = (state_42267[(7)]);
var state_42267__$1 = state_42267;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_42267__$1,(11),to,inst_42246);
} else {
if((state_val_42268 === (3))){
var inst_42265 = (state_42267[(2)]);
var state_42267__$1 = state_42267;
return cljs.core.async.impl.ioc_helpers.return_chan(state_42267__$1,inst_42265);
} else {
if((state_val_42268 === (12))){
var state_42267__$1 = state_42267;
var statearr_42275_42301 = state_42267__$1;
(statearr_42275_42301[(2)] = null);

(statearr_42275_42301[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (2))){
var state_42267__$1 = state_42267;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42267__$1,(4),from);
} else {
if((state_val_42268 === (11))){
var inst_42256 = (state_42267[(2)]);
var state_42267__$1 = state_42267;
if(cljs.core.truth_(inst_42256)){
var statearr_42276_42302 = state_42267__$1;
(statearr_42276_42302[(1)] = (12));

} else {
var statearr_42277_42303 = state_42267__$1;
(statearr_42277_42303[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (9))){
var state_42267__$1 = state_42267;
var statearr_42278_42304 = state_42267__$1;
(statearr_42278_42304[(2)] = null);

(statearr_42278_42304[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (5))){
var state_42267__$1 = state_42267;
if(cljs.core.truth_(close_QMARK_)){
var statearr_42279_42305 = state_42267__$1;
(statearr_42279_42305[(1)] = (8));

} else {
var statearr_42280_42306 = state_42267__$1;
(statearr_42280_42306[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (14))){
var inst_42261 = (state_42267[(2)]);
var state_42267__$1 = state_42267;
var statearr_42281_42307 = state_42267__$1;
(statearr_42281_42307[(2)] = inst_42261);

(statearr_42281_42307[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (10))){
var inst_42253 = (state_42267[(2)]);
var state_42267__$1 = state_42267;
var statearr_42282_42308 = state_42267__$1;
(statearr_42282_42308[(2)] = inst_42253);

(statearr_42282_42308[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42268 === (8))){
var inst_42250 = cljs.core.async.close_BANG_(to);
var state_42267__$1 = state_42267;
var statearr_42283_42309 = state_42267__$1;
(statearr_42283_42309[(2)] = inst_42250);

(statearr_42283_42309[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___42295))
;
return ((function (switch__41984__auto__,c__42110__auto___42295){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_42287 = [null,null,null,null,null,null,null,null];
(statearr_42287[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_42287[(1)] = (1));

return statearr_42287;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_42267){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42267);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42288){if((e42288 instanceof Object)){
var ex__41988__auto__ = e42288;
var statearr_42289_42310 = state_42267;
(statearr_42289_42310[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42267);

return cljs.core.cst$kw$recur;
} else {
throw e42288;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__42311 = state_42267;
state_42267 = G__42311;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_42267){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_42267);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___42295))
})();
var state__42112__auto__ = (function (){var statearr_42290 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42290[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___42295);

return statearr_42290;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___42295))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var results = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var process = ((function (jobs,results){
return (function (p__42499){
var vec__42500 = p__42499;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__42500,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__42500,(1),null);
var job = vec__42500;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((1),xf,ex_handler);
var c__42110__auto___42686 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___42686,res,vec__42500,v,p,job,jobs,results){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___42686,res,vec__42500,v,p,job,jobs,results){
return (function (state_42507){
var state_val_42508 = (state_42507[(1)]);
if((state_val_42508 === (1))){
var state_42507__$1 = state_42507;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_42507__$1,(2),res,v);
} else {
if((state_val_42508 === (2))){
var inst_42504 = (state_42507[(2)]);
var inst_42505 = cljs.core.async.close_BANG_(res);
var state_42507__$1 = (function (){var statearr_42509 = state_42507;
(statearr_42509[(7)] = inst_42504);

return statearr_42509;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_42507__$1,inst_42505);
} else {
return null;
}
}
});})(c__42110__auto___42686,res,vec__42500,v,p,job,jobs,results))
;
return ((function (switch__41984__auto__,c__42110__auto___42686,res,vec__42500,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0 = (function (){
var statearr_42513 = [null,null,null,null,null,null,null,null];
(statearr_42513[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__);

(statearr_42513[(1)] = (1));

return statearr_42513;
});
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1 = (function (state_42507){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42507);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42514){if((e42514 instanceof Object)){
var ex__41988__auto__ = e42514;
var statearr_42515_42687 = state_42507;
(statearr_42515_42687[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42507);

return cljs.core.cst$kw$recur;
} else {
throw e42514;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__42688 = state_42507;
state_42507 = G__42688;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = function(state_42507){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1.call(this,state_42507);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___42686,res,vec__42500,v,p,job,jobs,results))
})();
var state__42112__auto__ = (function (){var statearr_42516 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42516[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___42686);

return statearr_42516;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___42686,res,vec__42500,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__42517){
var vec__42518 = p__42517;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__42518,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__42518,(1),null);
var job = vec__42518;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
(xf.cljs$core$IFn$_invoke$arity$2 ? xf.cljs$core$IFn$_invoke$arity$2(v,res) : xf.call(null,v,res));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results,process))
;
var n__10291__auto___42689 = n;
var __42690 = (0);
while(true){
if((__42690 < n__10291__auto___42689)){
var G__42521_42691 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__42521_42691) {
case "compute":
var c__42110__auto___42693 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__42690,c__42110__auto___42693,G__42521_42691,n__10291__auto___42689,jobs,results,process,async){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (__42690,c__42110__auto___42693,G__42521_42691,n__10291__auto___42689,jobs,results,process,async){
return (function (state_42534){
var state_val_42535 = (state_42534[(1)]);
if((state_val_42535 === (1))){
var state_42534__$1 = state_42534;
var statearr_42536_42694 = state_42534__$1;
(statearr_42536_42694[(2)] = null);

(statearr_42536_42694[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42535 === (2))){
var state_42534__$1 = state_42534;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42534__$1,(4),jobs);
} else {
if((state_val_42535 === (3))){
var inst_42532 = (state_42534[(2)]);
var state_42534__$1 = state_42534;
return cljs.core.async.impl.ioc_helpers.return_chan(state_42534__$1,inst_42532);
} else {
if((state_val_42535 === (4))){
var inst_42524 = (state_42534[(2)]);
var inst_42525 = process(inst_42524);
var state_42534__$1 = state_42534;
if(cljs.core.truth_(inst_42525)){
var statearr_42537_42695 = state_42534__$1;
(statearr_42537_42695[(1)] = (5));

} else {
var statearr_42538_42696 = state_42534__$1;
(statearr_42538_42696[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42535 === (5))){
var state_42534__$1 = state_42534;
var statearr_42539_42697 = state_42534__$1;
(statearr_42539_42697[(2)] = null);

(statearr_42539_42697[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42535 === (6))){
var state_42534__$1 = state_42534;
var statearr_42540_42698 = state_42534__$1;
(statearr_42540_42698[(2)] = null);

(statearr_42540_42698[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42535 === (7))){
var inst_42530 = (state_42534[(2)]);
var state_42534__$1 = state_42534;
var statearr_42541_42699 = state_42534__$1;
(statearr_42541_42699[(2)] = inst_42530);

(statearr_42541_42699[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(__42690,c__42110__auto___42693,G__42521_42691,n__10291__auto___42689,jobs,results,process,async))
;
return ((function (__42690,switch__41984__auto__,c__42110__auto___42693,G__42521_42691,n__10291__auto___42689,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0 = (function (){
var statearr_42545 = [null,null,null,null,null,null,null];
(statearr_42545[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__);

(statearr_42545[(1)] = (1));

return statearr_42545;
});
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1 = (function (state_42534){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42534);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42546){if((e42546 instanceof Object)){
var ex__41988__auto__ = e42546;
var statearr_42547_42700 = state_42534;
(statearr_42547_42700[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42534);

return cljs.core.cst$kw$recur;
} else {
throw e42546;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__42701 = state_42534;
state_42534 = G__42701;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = function(state_42534){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1.call(this,state_42534);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__;
})()
;})(__42690,switch__41984__auto__,c__42110__auto___42693,G__42521_42691,n__10291__auto___42689,jobs,results,process,async))
})();
var state__42112__auto__ = (function (){var statearr_42548 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42548[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___42693);

return statearr_42548;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(__42690,c__42110__auto___42693,G__42521_42691,n__10291__auto___42689,jobs,results,process,async))
);


break;
case "async":
var c__42110__auto___42702 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__42690,c__42110__auto___42702,G__42521_42691,n__10291__auto___42689,jobs,results,process,async){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (__42690,c__42110__auto___42702,G__42521_42691,n__10291__auto___42689,jobs,results,process,async){
return (function (state_42561){
var state_val_42562 = (state_42561[(1)]);
if((state_val_42562 === (1))){
var state_42561__$1 = state_42561;
var statearr_42563_42703 = state_42561__$1;
(statearr_42563_42703[(2)] = null);

(statearr_42563_42703[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42562 === (2))){
var state_42561__$1 = state_42561;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42561__$1,(4),jobs);
} else {
if((state_val_42562 === (3))){
var inst_42559 = (state_42561[(2)]);
var state_42561__$1 = state_42561;
return cljs.core.async.impl.ioc_helpers.return_chan(state_42561__$1,inst_42559);
} else {
if((state_val_42562 === (4))){
var inst_42551 = (state_42561[(2)]);
var inst_42552 = async(inst_42551);
var state_42561__$1 = state_42561;
if(cljs.core.truth_(inst_42552)){
var statearr_42564_42704 = state_42561__$1;
(statearr_42564_42704[(1)] = (5));

} else {
var statearr_42565_42705 = state_42561__$1;
(statearr_42565_42705[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42562 === (5))){
var state_42561__$1 = state_42561;
var statearr_42566_42706 = state_42561__$1;
(statearr_42566_42706[(2)] = null);

(statearr_42566_42706[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42562 === (6))){
var state_42561__$1 = state_42561;
var statearr_42567_42707 = state_42561__$1;
(statearr_42567_42707[(2)] = null);

(statearr_42567_42707[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42562 === (7))){
var inst_42557 = (state_42561[(2)]);
var state_42561__$1 = state_42561;
var statearr_42568_42708 = state_42561__$1;
(statearr_42568_42708[(2)] = inst_42557);

(statearr_42568_42708[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(__42690,c__42110__auto___42702,G__42521_42691,n__10291__auto___42689,jobs,results,process,async))
;
return ((function (__42690,switch__41984__auto__,c__42110__auto___42702,G__42521_42691,n__10291__auto___42689,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0 = (function (){
var statearr_42572 = [null,null,null,null,null,null,null];
(statearr_42572[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__);

(statearr_42572[(1)] = (1));

return statearr_42572;
});
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1 = (function (state_42561){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42561);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42573){if((e42573 instanceof Object)){
var ex__41988__auto__ = e42573;
var statearr_42574_42709 = state_42561;
(statearr_42574_42709[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42561);

return cljs.core.cst$kw$recur;
} else {
throw e42573;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__42710 = state_42561;
state_42561 = G__42710;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = function(state_42561){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1.call(this,state_42561);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__;
})()
;})(__42690,switch__41984__auto__,c__42110__auto___42702,G__42521_42691,n__10291__auto___42689,jobs,results,process,async))
})();
var state__42112__auto__ = (function (){var statearr_42575 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42575[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___42702);

return statearr_42575;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(__42690,c__42110__auto___42702,G__42521_42691,n__10291__auto___42689,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__42711 = (__42690 + (1));
__42690 = G__42711;
continue;
} else {
}
break;
}

var c__42110__auto___42712 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___42712,jobs,results,process,async){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___42712,jobs,results,process,async){
return (function (state_42597){
var state_val_42598 = (state_42597[(1)]);
if((state_val_42598 === (1))){
var state_42597__$1 = state_42597;
var statearr_42599_42713 = state_42597__$1;
(statearr_42599_42713[(2)] = null);

(statearr_42599_42713[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42598 === (2))){
var state_42597__$1 = state_42597;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42597__$1,(4),from);
} else {
if((state_val_42598 === (3))){
var inst_42595 = (state_42597[(2)]);
var state_42597__$1 = state_42597;
return cljs.core.async.impl.ioc_helpers.return_chan(state_42597__$1,inst_42595);
} else {
if((state_val_42598 === (4))){
var inst_42578 = (state_42597[(7)]);
var inst_42578__$1 = (state_42597[(2)]);
var inst_42579 = (inst_42578__$1 == null);
var state_42597__$1 = (function (){var statearr_42600 = state_42597;
(statearr_42600[(7)] = inst_42578__$1);

return statearr_42600;
})();
if(cljs.core.truth_(inst_42579)){
var statearr_42601_42714 = state_42597__$1;
(statearr_42601_42714[(1)] = (5));

} else {
var statearr_42602_42715 = state_42597__$1;
(statearr_42602_42715[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42598 === (5))){
var inst_42581 = cljs.core.async.close_BANG_(jobs);
var state_42597__$1 = state_42597;
var statearr_42603_42716 = state_42597__$1;
(statearr_42603_42716[(2)] = inst_42581);

(statearr_42603_42716[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42598 === (6))){
var inst_42578 = (state_42597[(7)]);
var inst_42583 = (state_42597[(8)]);
var inst_42583__$1 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_42584 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_42585 = [inst_42578,inst_42583__$1];
var inst_42586 = (new cljs.core.PersistentVector(null,2,(5),inst_42584,inst_42585,null));
var state_42597__$1 = (function (){var statearr_42604 = state_42597;
(statearr_42604[(8)] = inst_42583__$1);

return statearr_42604;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_42597__$1,(8),jobs,inst_42586);
} else {
if((state_val_42598 === (7))){
var inst_42593 = (state_42597[(2)]);
var state_42597__$1 = state_42597;
var statearr_42605_42717 = state_42597__$1;
(statearr_42605_42717[(2)] = inst_42593);

(statearr_42605_42717[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42598 === (8))){
var inst_42583 = (state_42597[(8)]);
var inst_42588 = (state_42597[(2)]);
var state_42597__$1 = (function (){var statearr_42606 = state_42597;
(statearr_42606[(9)] = inst_42588);

return statearr_42606;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_42597__$1,(9),results,inst_42583);
} else {
if((state_val_42598 === (9))){
var inst_42590 = (state_42597[(2)]);
var state_42597__$1 = (function (){var statearr_42607 = state_42597;
(statearr_42607[(10)] = inst_42590);

return statearr_42607;
})();
var statearr_42608_42718 = state_42597__$1;
(statearr_42608_42718[(2)] = null);

(statearr_42608_42718[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___42712,jobs,results,process,async))
;
return ((function (switch__41984__auto__,c__42110__auto___42712,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0 = (function (){
var statearr_42612 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_42612[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__);

(statearr_42612[(1)] = (1));

return statearr_42612;
});
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1 = (function (state_42597){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42597);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42613){if((e42613 instanceof Object)){
var ex__41988__auto__ = e42613;
var statearr_42614_42719 = state_42597;
(statearr_42614_42719[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42597);

return cljs.core.cst$kw$recur;
} else {
throw e42613;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__42720 = state_42597;
state_42597 = G__42720;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = function(state_42597){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1.call(this,state_42597);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___42712,jobs,results,process,async))
})();
var state__42112__auto__ = (function (){var statearr_42615 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42615[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___42712);

return statearr_42615;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___42712,jobs,results,process,async))
);


var c__42110__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto__,jobs,results,process,async){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto__,jobs,results,process,async){
return (function (state_42653){
var state_val_42654 = (state_42653[(1)]);
if((state_val_42654 === (7))){
var inst_42649 = (state_42653[(2)]);
var state_42653__$1 = state_42653;
var statearr_42655_42721 = state_42653__$1;
(statearr_42655_42721[(2)] = inst_42649);

(statearr_42655_42721[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (20))){
var state_42653__$1 = state_42653;
var statearr_42656_42722 = state_42653__$1;
(statearr_42656_42722[(2)] = null);

(statearr_42656_42722[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (1))){
var state_42653__$1 = state_42653;
var statearr_42657_42723 = state_42653__$1;
(statearr_42657_42723[(2)] = null);

(statearr_42657_42723[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (4))){
var inst_42618 = (state_42653[(7)]);
var inst_42618__$1 = (state_42653[(2)]);
var inst_42619 = (inst_42618__$1 == null);
var state_42653__$1 = (function (){var statearr_42658 = state_42653;
(statearr_42658[(7)] = inst_42618__$1);

return statearr_42658;
})();
if(cljs.core.truth_(inst_42619)){
var statearr_42659_42724 = state_42653__$1;
(statearr_42659_42724[(1)] = (5));

} else {
var statearr_42660_42725 = state_42653__$1;
(statearr_42660_42725[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (15))){
var inst_42631 = (state_42653[(8)]);
var state_42653__$1 = state_42653;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_42653__$1,(18),to,inst_42631);
} else {
if((state_val_42654 === (21))){
var inst_42644 = (state_42653[(2)]);
var state_42653__$1 = state_42653;
var statearr_42661_42726 = state_42653__$1;
(statearr_42661_42726[(2)] = inst_42644);

(statearr_42661_42726[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (13))){
var inst_42646 = (state_42653[(2)]);
var state_42653__$1 = (function (){var statearr_42662 = state_42653;
(statearr_42662[(9)] = inst_42646);

return statearr_42662;
})();
var statearr_42663_42727 = state_42653__$1;
(statearr_42663_42727[(2)] = null);

(statearr_42663_42727[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (6))){
var inst_42618 = (state_42653[(7)]);
var state_42653__$1 = state_42653;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42653__$1,(11),inst_42618);
} else {
if((state_val_42654 === (17))){
var inst_42639 = (state_42653[(2)]);
var state_42653__$1 = state_42653;
if(cljs.core.truth_(inst_42639)){
var statearr_42664_42728 = state_42653__$1;
(statearr_42664_42728[(1)] = (19));

} else {
var statearr_42665_42729 = state_42653__$1;
(statearr_42665_42729[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (3))){
var inst_42651 = (state_42653[(2)]);
var state_42653__$1 = state_42653;
return cljs.core.async.impl.ioc_helpers.return_chan(state_42653__$1,inst_42651);
} else {
if((state_val_42654 === (12))){
var inst_42628 = (state_42653[(10)]);
var state_42653__$1 = state_42653;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42653__$1,(14),inst_42628);
} else {
if((state_val_42654 === (2))){
var state_42653__$1 = state_42653;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42653__$1,(4),results);
} else {
if((state_val_42654 === (19))){
var state_42653__$1 = state_42653;
var statearr_42666_42730 = state_42653__$1;
(statearr_42666_42730[(2)] = null);

(statearr_42666_42730[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (11))){
var inst_42628 = (state_42653[(2)]);
var state_42653__$1 = (function (){var statearr_42667 = state_42653;
(statearr_42667[(10)] = inst_42628);

return statearr_42667;
})();
var statearr_42668_42731 = state_42653__$1;
(statearr_42668_42731[(2)] = null);

(statearr_42668_42731[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (9))){
var state_42653__$1 = state_42653;
var statearr_42669_42732 = state_42653__$1;
(statearr_42669_42732[(2)] = null);

(statearr_42669_42732[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (5))){
var state_42653__$1 = state_42653;
if(cljs.core.truth_(close_QMARK_)){
var statearr_42670_42733 = state_42653__$1;
(statearr_42670_42733[(1)] = (8));

} else {
var statearr_42671_42734 = state_42653__$1;
(statearr_42671_42734[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (14))){
var inst_42631 = (state_42653[(8)]);
var inst_42633 = (state_42653[(11)]);
var inst_42631__$1 = (state_42653[(2)]);
var inst_42632 = (inst_42631__$1 == null);
var inst_42633__$1 = cljs.core.not(inst_42632);
var state_42653__$1 = (function (){var statearr_42672 = state_42653;
(statearr_42672[(8)] = inst_42631__$1);

(statearr_42672[(11)] = inst_42633__$1);

return statearr_42672;
})();
if(inst_42633__$1){
var statearr_42673_42735 = state_42653__$1;
(statearr_42673_42735[(1)] = (15));

} else {
var statearr_42674_42736 = state_42653__$1;
(statearr_42674_42736[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (16))){
var inst_42633 = (state_42653[(11)]);
var state_42653__$1 = state_42653;
var statearr_42675_42737 = state_42653__$1;
(statearr_42675_42737[(2)] = inst_42633);

(statearr_42675_42737[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (10))){
var inst_42625 = (state_42653[(2)]);
var state_42653__$1 = state_42653;
var statearr_42676_42738 = state_42653__$1;
(statearr_42676_42738[(2)] = inst_42625);

(statearr_42676_42738[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (18))){
var inst_42636 = (state_42653[(2)]);
var state_42653__$1 = state_42653;
var statearr_42677_42739 = state_42653__$1;
(statearr_42677_42739[(2)] = inst_42636);

(statearr_42677_42739[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42654 === (8))){
var inst_42622 = cljs.core.async.close_BANG_(to);
var state_42653__$1 = state_42653;
var statearr_42678_42740 = state_42653__$1;
(statearr_42678_42740[(2)] = inst_42622);

(statearr_42678_42740[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto__,jobs,results,process,async))
;
return ((function (switch__41984__auto__,c__42110__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0 = (function (){
var statearr_42682 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_42682[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__);

(statearr_42682[(1)] = (1));

return statearr_42682;
});
var cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1 = (function (state_42653){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42653);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42683){if((e42683 instanceof Object)){
var ex__41988__auto__ = e42683;
var statearr_42684_42741 = state_42653;
(statearr_42684_42741[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42653);

return cljs.core.cst$kw$recur;
} else {
throw e42683;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__42742 = state_42653;
state_42653 = G__42742;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__ = function(state_42653){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1.call(this,state_42653);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__41985__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto__,jobs,results,process,async))
})();
var state__42112__auto__ = (function (){var statearr_42685 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42685[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto__);

return statearr_42685;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto__,jobs,results,process,async))
);

return c__42110__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var args42743 = [];
var len__10461__auto___42746 = arguments.length;
var i__10462__auto___42747 = (0);
while(true){
if((i__10462__auto___42747 < len__10461__auto___42746)){
args42743.push((arguments[i__10462__auto___42747]));

var G__42748 = (i__10462__auto___42747 + (1));
i__10462__auto___42747 = G__42748;
continue;
} else {
}
break;
}

var G__42745 = args42743.length;
switch (G__42745) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42743.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5(n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_(n,to,af,from,close_QMARK_,null,cljs.core.cst$kw$async);
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var args42750 = [];
var len__10461__auto___42753 = arguments.length;
var i__10462__auto___42754 = (0);
while(true){
if((i__10462__auto___42754 < len__10461__auto___42753)){
args42750.push((arguments[i__10462__auto___42754]));

var G__42755 = (i__10462__auto___42754 + (1));
i__10462__auto___42754 = G__42755;
continue;
} else {
}
break;
}

var G__42752 = args42750.length;
switch (G__42752) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42750.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5(n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6(n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,cljs.core.cst$kw$compute);
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args42757 = [];
var len__10461__auto___42810 = arguments.length;
var i__10462__auto___42811 = (0);
while(true){
if((i__10462__auto___42811 < len__10461__auto___42810)){
args42757.push((arguments[i__10462__auto___42811]));

var G__42812 = (i__10462__auto___42811 + (1));
i__10462__auto___42811 = G__42812;
continue;
} else {
}
break;
}

var G__42759 = args42757.length;
switch (G__42759) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42757.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__42110__auto___42814 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___42814,tc,fc){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___42814,tc,fc){
return (function (state_42785){
var state_val_42786 = (state_42785[(1)]);
if((state_val_42786 === (7))){
var inst_42781 = (state_42785[(2)]);
var state_42785__$1 = state_42785;
var statearr_42787_42815 = state_42785__$1;
(statearr_42787_42815[(2)] = inst_42781);

(statearr_42787_42815[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (1))){
var state_42785__$1 = state_42785;
var statearr_42788_42816 = state_42785__$1;
(statearr_42788_42816[(2)] = null);

(statearr_42788_42816[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (4))){
var inst_42762 = (state_42785[(7)]);
var inst_42762__$1 = (state_42785[(2)]);
var inst_42763 = (inst_42762__$1 == null);
var state_42785__$1 = (function (){var statearr_42789 = state_42785;
(statearr_42789[(7)] = inst_42762__$1);

return statearr_42789;
})();
if(cljs.core.truth_(inst_42763)){
var statearr_42790_42817 = state_42785__$1;
(statearr_42790_42817[(1)] = (5));

} else {
var statearr_42791_42818 = state_42785__$1;
(statearr_42791_42818[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (13))){
var state_42785__$1 = state_42785;
var statearr_42792_42819 = state_42785__$1;
(statearr_42792_42819[(2)] = null);

(statearr_42792_42819[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (6))){
var inst_42762 = (state_42785[(7)]);
var inst_42768 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_42762) : p.call(null,inst_42762));
var state_42785__$1 = state_42785;
if(cljs.core.truth_(inst_42768)){
var statearr_42793_42820 = state_42785__$1;
(statearr_42793_42820[(1)] = (9));

} else {
var statearr_42794_42821 = state_42785__$1;
(statearr_42794_42821[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (3))){
var inst_42783 = (state_42785[(2)]);
var state_42785__$1 = state_42785;
return cljs.core.async.impl.ioc_helpers.return_chan(state_42785__$1,inst_42783);
} else {
if((state_val_42786 === (12))){
var state_42785__$1 = state_42785;
var statearr_42795_42822 = state_42785__$1;
(statearr_42795_42822[(2)] = null);

(statearr_42795_42822[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (2))){
var state_42785__$1 = state_42785;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42785__$1,(4),ch);
} else {
if((state_val_42786 === (11))){
var inst_42762 = (state_42785[(7)]);
var inst_42772 = (state_42785[(2)]);
var state_42785__$1 = state_42785;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_42785__$1,(8),inst_42772,inst_42762);
} else {
if((state_val_42786 === (9))){
var state_42785__$1 = state_42785;
var statearr_42796_42823 = state_42785__$1;
(statearr_42796_42823[(2)] = tc);

(statearr_42796_42823[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (5))){
var inst_42765 = cljs.core.async.close_BANG_(tc);
var inst_42766 = cljs.core.async.close_BANG_(fc);
var state_42785__$1 = (function (){var statearr_42797 = state_42785;
(statearr_42797[(8)] = inst_42765);

return statearr_42797;
})();
var statearr_42798_42824 = state_42785__$1;
(statearr_42798_42824[(2)] = inst_42766);

(statearr_42798_42824[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (14))){
var inst_42779 = (state_42785[(2)]);
var state_42785__$1 = state_42785;
var statearr_42799_42825 = state_42785__$1;
(statearr_42799_42825[(2)] = inst_42779);

(statearr_42799_42825[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (10))){
var state_42785__$1 = state_42785;
var statearr_42800_42826 = state_42785__$1;
(statearr_42800_42826[(2)] = fc);

(statearr_42800_42826[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42786 === (8))){
var inst_42774 = (state_42785[(2)]);
var state_42785__$1 = state_42785;
if(cljs.core.truth_(inst_42774)){
var statearr_42801_42827 = state_42785__$1;
(statearr_42801_42827[(1)] = (12));

} else {
var statearr_42802_42828 = state_42785__$1;
(statearr_42802_42828[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___42814,tc,fc))
;
return ((function (switch__41984__auto__,c__42110__auto___42814,tc,fc){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_42806 = [null,null,null,null,null,null,null,null,null];
(statearr_42806[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_42806[(1)] = (1));

return statearr_42806;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_42785){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42785);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42807){if((e42807 instanceof Object)){
var ex__41988__auto__ = e42807;
var statearr_42808_42829 = state_42785;
(statearr_42808_42829[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42785);

return cljs.core.cst$kw$recur;
} else {
throw e42807;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__42830 = state_42785;
state_42785 = G__42830;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_42785){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_42785);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___42814,tc,fc))
})();
var state__42112__auto__ = (function (){var statearr_42809 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42809[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___42814);

return statearr_42809;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___42814,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__42110__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto__){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto__){
return (function (state_42894){
var state_val_42895 = (state_42894[(1)]);
if((state_val_42895 === (7))){
var inst_42890 = (state_42894[(2)]);
var state_42894__$1 = state_42894;
var statearr_42896_42917 = state_42894__$1;
(statearr_42896_42917[(2)] = inst_42890);

(statearr_42896_42917[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42895 === (1))){
var inst_42874 = init;
var state_42894__$1 = (function (){var statearr_42897 = state_42894;
(statearr_42897[(7)] = inst_42874);

return statearr_42897;
})();
var statearr_42898_42918 = state_42894__$1;
(statearr_42898_42918[(2)] = null);

(statearr_42898_42918[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42895 === (4))){
var inst_42877 = (state_42894[(8)]);
var inst_42877__$1 = (state_42894[(2)]);
var inst_42878 = (inst_42877__$1 == null);
var state_42894__$1 = (function (){var statearr_42899 = state_42894;
(statearr_42899[(8)] = inst_42877__$1);

return statearr_42899;
})();
if(cljs.core.truth_(inst_42878)){
var statearr_42900_42919 = state_42894__$1;
(statearr_42900_42919[(1)] = (5));

} else {
var statearr_42901_42920 = state_42894__$1;
(statearr_42901_42920[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42895 === (6))){
var inst_42874 = (state_42894[(7)]);
var inst_42877 = (state_42894[(8)]);
var inst_42881 = (state_42894[(9)]);
var inst_42881__$1 = (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(inst_42874,inst_42877) : f.call(null,inst_42874,inst_42877));
var inst_42882 = cljs.core.reduced_QMARK_(inst_42881__$1);
var state_42894__$1 = (function (){var statearr_42902 = state_42894;
(statearr_42902[(9)] = inst_42881__$1);

return statearr_42902;
})();
if(inst_42882){
var statearr_42903_42921 = state_42894__$1;
(statearr_42903_42921[(1)] = (8));

} else {
var statearr_42904_42922 = state_42894__$1;
(statearr_42904_42922[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42895 === (3))){
var inst_42892 = (state_42894[(2)]);
var state_42894__$1 = state_42894;
return cljs.core.async.impl.ioc_helpers.return_chan(state_42894__$1,inst_42892);
} else {
if((state_val_42895 === (2))){
var state_42894__$1 = state_42894;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_42894__$1,(4),ch);
} else {
if((state_val_42895 === (9))){
var inst_42881 = (state_42894[(9)]);
var inst_42874 = inst_42881;
var state_42894__$1 = (function (){var statearr_42905 = state_42894;
(statearr_42905[(7)] = inst_42874);

return statearr_42905;
})();
var statearr_42906_42923 = state_42894__$1;
(statearr_42906_42923[(2)] = null);

(statearr_42906_42923[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42895 === (5))){
var inst_42874 = (state_42894[(7)]);
var state_42894__$1 = state_42894;
var statearr_42907_42924 = state_42894__$1;
(statearr_42907_42924[(2)] = inst_42874);

(statearr_42907_42924[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42895 === (10))){
var inst_42888 = (state_42894[(2)]);
var state_42894__$1 = state_42894;
var statearr_42908_42925 = state_42894__$1;
(statearr_42908_42925[(2)] = inst_42888);

(statearr_42908_42925[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42895 === (8))){
var inst_42881 = (state_42894[(9)]);
var inst_42884 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(inst_42881) : cljs.core.deref.call(null,inst_42881));
var state_42894__$1 = state_42894;
var statearr_42909_42926 = state_42894__$1;
(statearr_42909_42926[(2)] = inst_42884);

(statearr_42909_42926[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto__))
;
return ((function (switch__41984__auto__,c__42110__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__41985__auto__ = null;
var cljs$core$async$reduce_$_state_machine__41985__auto____0 = (function (){
var statearr_42913 = [null,null,null,null,null,null,null,null,null,null];
(statearr_42913[(0)] = cljs$core$async$reduce_$_state_machine__41985__auto__);

(statearr_42913[(1)] = (1));

return statearr_42913;
});
var cljs$core$async$reduce_$_state_machine__41985__auto____1 = (function (state_42894){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42894);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42914){if((e42914 instanceof Object)){
var ex__41988__auto__ = e42914;
var statearr_42915_42927 = state_42894;
(statearr_42915_42927[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42894);

return cljs.core.cst$kw$recur;
} else {
throw e42914;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__42928 = state_42894;
state_42894 = G__42928;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__41985__auto__ = function(state_42894){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__41985__auto____1.call(this,state_42894);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__41985__auto____0;
cljs$core$async$reduce_$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__41985__auto____1;
return cljs$core$async$reduce_$_state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto__))
})();
var state__42112__auto__ = (function (){var statearr_42916 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42916[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto__);

return statearr_42916;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto__))
);

return c__42110__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args42929 = [];
var len__10461__auto___42981 = arguments.length;
var i__10462__auto___42982 = (0);
while(true){
if((i__10462__auto___42982 < len__10461__auto___42981)){
args42929.push((arguments[i__10462__auto___42982]));

var G__42983 = (i__10462__auto___42982 + (1));
i__10462__auto___42982 = G__42983;
continue;
} else {
}
break;
}

var G__42931 = args42929.length;
switch (G__42931) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args42929.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__42110__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto__){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto__){
return (function (state_42956){
var state_val_42957 = (state_42956[(1)]);
if((state_val_42957 === (7))){
var inst_42938 = (state_42956[(2)]);
var state_42956__$1 = state_42956;
var statearr_42958_42985 = state_42956__$1;
(statearr_42958_42985[(2)] = inst_42938);

(statearr_42958_42985[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (1))){
var inst_42932 = cljs.core.seq(coll);
var inst_42933 = inst_42932;
var state_42956__$1 = (function (){var statearr_42959 = state_42956;
(statearr_42959[(7)] = inst_42933);

return statearr_42959;
})();
var statearr_42960_42986 = state_42956__$1;
(statearr_42960_42986[(2)] = null);

(statearr_42960_42986[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (4))){
var inst_42933 = (state_42956[(7)]);
var inst_42936 = cljs.core.first(inst_42933);
var state_42956__$1 = state_42956;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_42956__$1,(7),ch,inst_42936);
} else {
if((state_val_42957 === (13))){
var inst_42950 = (state_42956[(2)]);
var state_42956__$1 = state_42956;
var statearr_42961_42987 = state_42956__$1;
(statearr_42961_42987[(2)] = inst_42950);

(statearr_42961_42987[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (6))){
var inst_42941 = (state_42956[(2)]);
var state_42956__$1 = state_42956;
if(cljs.core.truth_(inst_42941)){
var statearr_42962_42988 = state_42956__$1;
(statearr_42962_42988[(1)] = (8));

} else {
var statearr_42963_42989 = state_42956__$1;
(statearr_42963_42989[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (3))){
var inst_42954 = (state_42956[(2)]);
var state_42956__$1 = state_42956;
return cljs.core.async.impl.ioc_helpers.return_chan(state_42956__$1,inst_42954);
} else {
if((state_val_42957 === (12))){
var state_42956__$1 = state_42956;
var statearr_42964_42990 = state_42956__$1;
(statearr_42964_42990[(2)] = null);

(statearr_42964_42990[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (2))){
var inst_42933 = (state_42956[(7)]);
var state_42956__$1 = state_42956;
if(cljs.core.truth_(inst_42933)){
var statearr_42965_42991 = state_42956__$1;
(statearr_42965_42991[(1)] = (4));

} else {
var statearr_42966_42992 = state_42956__$1;
(statearr_42966_42992[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (11))){
var inst_42947 = cljs.core.async.close_BANG_(ch);
var state_42956__$1 = state_42956;
var statearr_42967_42993 = state_42956__$1;
(statearr_42967_42993[(2)] = inst_42947);

(statearr_42967_42993[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (9))){
var state_42956__$1 = state_42956;
if(cljs.core.truth_(close_QMARK_)){
var statearr_42968_42994 = state_42956__$1;
(statearr_42968_42994[(1)] = (11));

} else {
var statearr_42969_42995 = state_42956__$1;
(statearr_42969_42995[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (5))){
var inst_42933 = (state_42956[(7)]);
var state_42956__$1 = state_42956;
var statearr_42970_42996 = state_42956__$1;
(statearr_42970_42996[(2)] = inst_42933);

(statearr_42970_42996[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (10))){
var inst_42952 = (state_42956[(2)]);
var state_42956__$1 = state_42956;
var statearr_42971_42997 = state_42956__$1;
(statearr_42971_42997[(2)] = inst_42952);

(statearr_42971_42997[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_42957 === (8))){
var inst_42933 = (state_42956[(7)]);
var inst_42943 = cljs.core.next(inst_42933);
var inst_42933__$1 = inst_42943;
var state_42956__$1 = (function (){var statearr_42972 = state_42956;
(statearr_42972[(7)] = inst_42933__$1);

return statearr_42972;
})();
var statearr_42973_42998 = state_42956__$1;
(statearr_42973_42998[(2)] = null);

(statearr_42973_42998[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto__))
;
return ((function (switch__41984__auto__,c__42110__auto__){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_42977 = [null,null,null,null,null,null,null,null];
(statearr_42977[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_42977[(1)] = (1));

return statearr_42977;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_42956){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_42956);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e42978){if((e42978 instanceof Object)){
var ex__41988__auto__ = e42978;
var statearr_42979_42999 = state_42956;
(statearr_42979_42999[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_42956);

return cljs.core.cst$kw$recur;
} else {
throw e42978;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__43000 = state_42956;
state_42956 = G__43000;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_42956){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_42956);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto__))
})();
var state__42112__auto__ = (function (){var statearr_42980 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_42980[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto__);

return statearr_42980;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto__))
);

return c__42110__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__9991__auto__ = (((_ == null))?null:_);
var m__9992__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$1 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__9992__auto__.call(null,_));
} else {
var m__9992__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$1(_) : m__9992__auto____$1.call(null,_));
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__9991__auto__ = (((m == null))?null:m);
var m__9992__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$3 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__9992__auto__.call(null,m,ch,close_QMARK_));
} else {
var m__9992__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$3 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__9992__auto____$1.call(null,m,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__9991__auto__ = (((m == null))?null:m);
var m__9992__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__9992__auto__.call(null,m,ch));
} else {
var m__9992__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__9992__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__9991__auto__ = (((m == null))?null:m);
var m__9992__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$1 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__9992__auto__.call(null,m));
} else {
var m__9992__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$1(m) : m__9992__auto____$1.call(null,m));
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = (function (){var G__43229 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__43229) : cljs.core.atom.call(null,G__43229));
})();
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async43230 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async43230 = (function (mult,ch,cs,meta43231){
this.mult = mult;
this.ch = ch;
this.cs = cs;
this.meta43231 = meta43231;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async43230.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_43232,meta43231__$1){
var self__ = this;
var _43232__$1 = this;
return (new cljs.core.async.t_cljs$core$async43230(self__.mult,self__.ch,self__.cs,meta43231__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async43230.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_43232){
var self__ = this;
var _43232__$1 = this;
return self__.meta43231;
});})(cs))
;

cljs.core.async.t_cljs$core$async43230.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async43230.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async43230.prototype.cljs$core$async$Mult$ = true;

cljs.core.async.t_cljs$core$async43230.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async43230.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async43230.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__43233_43457 = self__.cs;
var G__43234_43458 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__43233_43457,G__43234_43458) : cljs.core.reset_BANG_.call(null,G__43233_43457,G__43234_43458));

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async43230.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$mult,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Creates and returns a mult(iple) of the supplied channel. Channels\n  containing copies of the channel can be created with 'tap', and\n  detached with 'untap'.\n\n  Each item is distributed to all taps in parallel and synchronously,\n  i.e. each tap must accept before the next item is distributed. Use\n  buffering/windowing to prevent slow taps from holding up the mult.\n\n  Items received when there are no taps get dropped.\n\n  If a tap puts to a closed channel, it will be removed from the mult."], null)),cljs.core.cst$sym$ch,cljs.core.cst$sym$cs,cljs.core.cst$sym$meta43231], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async43230.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async43230.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async43230";

cljs.core.async.t_cljs$core$async43230.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async43230");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async43230 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async43230(mult__$1,ch__$1,cs__$1,meta43231){
return (new cljs.core.async.t_cljs$core$async43230(mult__$1,ch__$1,cs__$1,meta43231));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async43230(cljs$core$async$mult,ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null) : cljs.core.atom.call(null,null));
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__42110__auto___43459 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___43459,cs,m,dchan,dctr,done){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___43459,cs,m,dchan,dctr,done){
return (function (state_43369){
var state_val_43370 = (state_43369[(1)]);
if((state_val_43370 === (7))){
var inst_43365 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43371_43460 = state_43369__$1;
(statearr_43371_43460[(2)] = inst_43365);

(statearr_43371_43460[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (20))){
var inst_43268 = (state_43369[(7)]);
var inst_43280 = cljs.core.first(inst_43268);
var inst_43281 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_43280,(0),null);
var inst_43282 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_43280,(1),null);
var state_43369__$1 = (function (){var statearr_43372 = state_43369;
(statearr_43372[(8)] = inst_43281);

return statearr_43372;
})();
if(cljs.core.truth_(inst_43282)){
var statearr_43373_43461 = state_43369__$1;
(statearr_43373_43461[(1)] = (22));

} else {
var statearr_43374_43462 = state_43369__$1;
(statearr_43374_43462[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (27))){
var inst_43317 = (state_43369[(9)]);
var inst_43310 = (state_43369[(10)]);
var inst_43312 = (state_43369[(11)]);
var inst_43237 = (state_43369[(12)]);
var inst_43317__$1 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_43310,inst_43312);
var inst_43318 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_43317__$1,inst_43237,done);
var state_43369__$1 = (function (){var statearr_43375 = state_43369;
(statearr_43375[(9)] = inst_43317__$1);

return statearr_43375;
})();
if(cljs.core.truth_(inst_43318)){
var statearr_43376_43463 = state_43369__$1;
(statearr_43376_43463[(1)] = (30));

} else {
var statearr_43377_43464 = state_43369__$1;
(statearr_43377_43464[(1)] = (31));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (1))){
var state_43369__$1 = state_43369;
var statearr_43378_43465 = state_43369__$1;
(statearr_43378_43465[(2)] = null);

(statearr_43378_43465[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (24))){
var inst_43268 = (state_43369[(7)]);
var inst_43287 = (state_43369[(2)]);
var inst_43288 = cljs.core.next(inst_43268);
var inst_43246 = inst_43288;
var inst_43247 = null;
var inst_43248 = (0);
var inst_43249 = (0);
var state_43369__$1 = (function (){var statearr_43379 = state_43369;
(statearr_43379[(13)] = inst_43249);

(statearr_43379[(14)] = inst_43246);

(statearr_43379[(15)] = inst_43247);

(statearr_43379[(16)] = inst_43248);

(statearr_43379[(17)] = inst_43287);

return statearr_43379;
})();
var statearr_43380_43466 = state_43369__$1;
(statearr_43380_43466[(2)] = null);

(statearr_43380_43466[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (39))){
var state_43369__$1 = state_43369;
var statearr_43384_43467 = state_43369__$1;
(statearr_43384_43467[(2)] = null);

(statearr_43384_43467[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (4))){
var inst_43237 = (state_43369[(12)]);
var inst_43237__$1 = (state_43369[(2)]);
var inst_43238 = (inst_43237__$1 == null);
var state_43369__$1 = (function (){var statearr_43385 = state_43369;
(statearr_43385[(12)] = inst_43237__$1);

return statearr_43385;
})();
if(cljs.core.truth_(inst_43238)){
var statearr_43386_43468 = state_43369__$1;
(statearr_43386_43468[(1)] = (5));

} else {
var statearr_43387_43469 = state_43369__$1;
(statearr_43387_43469[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (15))){
var inst_43249 = (state_43369[(13)]);
var inst_43246 = (state_43369[(14)]);
var inst_43247 = (state_43369[(15)]);
var inst_43248 = (state_43369[(16)]);
var inst_43264 = (state_43369[(2)]);
var inst_43265 = (inst_43249 + (1));
var tmp43381 = inst_43246;
var tmp43382 = inst_43247;
var tmp43383 = inst_43248;
var inst_43246__$1 = tmp43381;
var inst_43247__$1 = tmp43382;
var inst_43248__$1 = tmp43383;
var inst_43249__$1 = inst_43265;
var state_43369__$1 = (function (){var statearr_43388 = state_43369;
(statearr_43388[(13)] = inst_43249__$1);

(statearr_43388[(14)] = inst_43246__$1);

(statearr_43388[(15)] = inst_43247__$1);

(statearr_43388[(16)] = inst_43248__$1);

(statearr_43388[(18)] = inst_43264);

return statearr_43388;
})();
var statearr_43389_43470 = state_43369__$1;
(statearr_43389_43470[(2)] = null);

(statearr_43389_43470[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (21))){
var inst_43291 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43393_43471 = state_43369__$1;
(statearr_43393_43471[(2)] = inst_43291);

(statearr_43393_43471[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (31))){
var inst_43317 = (state_43369[(9)]);
var inst_43321 = done(null);
var inst_43322 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_43317);
var state_43369__$1 = (function (){var statearr_43394 = state_43369;
(statearr_43394[(19)] = inst_43321);

return statearr_43394;
})();
var statearr_43395_43472 = state_43369__$1;
(statearr_43395_43472[(2)] = inst_43322);

(statearr_43395_43472[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (32))){
var inst_43310 = (state_43369[(10)]);
var inst_43312 = (state_43369[(11)]);
var inst_43311 = (state_43369[(20)]);
var inst_43309 = (state_43369[(21)]);
var inst_43324 = (state_43369[(2)]);
var inst_43325 = (inst_43312 + (1));
var tmp43390 = inst_43310;
var tmp43391 = inst_43311;
var tmp43392 = inst_43309;
var inst_43309__$1 = tmp43392;
var inst_43310__$1 = tmp43390;
var inst_43311__$1 = tmp43391;
var inst_43312__$1 = inst_43325;
var state_43369__$1 = (function (){var statearr_43396 = state_43369;
(statearr_43396[(10)] = inst_43310__$1);

(statearr_43396[(11)] = inst_43312__$1);

(statearr_43396[(20)] = inst_43311__$1);

(statearr_43396[(21)] = inst_43309__$1);

(statearr_43396[(22)] = inst_43324);

return statearr_43396;
})();
var statearr_43397_43473 = state_43369__$1;
(statearr_43397_43473[(2)] = null);

(statearr_43397_43473[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (40))){
var inst_43337 = (state_43369[(23)]);
var inst_43341 = done(null);
var inst_43342 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_43337);
var state_43369__$1 = (function (){var statearr_43398 = state_43369;
(statearr_43398[(24)] = inst_43341);

return statearr_43398;
})();
var statearr_43399_43474 = state_43369__$1;
(statearr_43399_43474[(2)] = inst_43342);

(statearr_43399_43474[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (33))){
var inst_43328 = (state_43369[(25)]);
var inst_43330 = cljs.core.chunked_seq_QMARK_(inst_43328);
var state_43369__$1 = state_43369;
if(inst_43330){
var statearr_43400_43475 = state_43369__$1;
(statearr_43400_43475[(1)] = (36));

} else {
var statearr_43401_43476 = state_43369__$1;
(statearr_43401_43476[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (13))){
var inst_43258 = (state_43369[(26)]);
var inst_43261 = cljs.core.async.close_BANG_(inst_43258);
var state_43369__$1 = state_43369;
var statearr_43402_43477 = state_43369__$1;
(statearr_43402_43477[(2)] = inst_43261);

(statearr_43402_43477[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (22))){
var inst_43281 = (state_43369[(8)]);
var inst_43284 = cljs.core.async.close_BANG_(inst_43281);
var state_43369__$1 = state_43369;
var statearr_43403_43478 = state_43369__$1;
(statearr_43403_43478[(2)] = inst_43284);

(statearr_43403_43478[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (36))){
var inst_43328 = (state_43369[(25)]);
var inst_43332 = cljs.core.chunk_first(inst_43328);
var inst_43333 = cljs.core.chunk_rest(inst_43328);
var inst_43334 = cljs.core.count(inst_43332);
var inst_43309 = inst_43333;
var inst_43310 = inst_43332;
var inst_43311 = inst_43334;
var inst_43312 = (0);
var state_43369__$1 = (function (){var statearr_43404 = state_43369;
(statearr_43404[(10)] = inst_43310);

(statearr_43404[(11)] = inst_43312);

(statearr_43404[(20)] = inst_43311);

(statearr_43404[(21)] = inst_43309);

return statearr_43404;
})();
var statearr_43405_43479 = state_43369__$1;
(statearr_43405_43479[(2)] = null);

(statearr_43405_43479[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (41))){
var inst_43328 = (state_43369[(25)]);
var inst_43344 = (state_43369[(2)]);
var inst_43345 = cljs.core.next(inst_43328);
var inst_43309 = inst_43345;
var inst_43310 = null;
var inst_43311 = (0);
var inst_43312 = (0);
var state_43369__$1 = (function (){var statearr_43406 = state_43369;
(statearr_43406[(10)] = inst_43310);

(statearr_43406[(11)] = inst_43312);

(statearr_43406[(20)] = inst_43311);

(statearr_43406[(21)] = inst_43309);

(statearr_43406[(27)] = inst_43344);

return statearr_43406;
})();
var statearr_43407_43480 = state_43369__$1;
(statearr_43407_43480[(2)] = null);

(statearr_43407_43480[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (43))){
var state_43369__$1 = state_43369;
var statearr_43408_43481 = state_43369__$1;
(statearr_43408_43481[(2)] = null);

(statearr_43408_43481[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (29))){
var inst_43353 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43409_43482 = state_43369__$1;
(statearr_43409_43482[(2)] = inst_43353);

(statearr_43409_43482[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (44))){
var inst_43362 = (state_43369[(2)]);
var state_43369__$1 = (function (){var statearr_43410 = state_43369;
(statearr_43410[(28)] = inst_43362);

return statearr_43410;
})();
var statearr_43411_43483 = state_43369__$1;
(statearr_43411_43483[(2)] = null);

(statearr_43411_43483[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (6))){
var inst_43301 = (state_43369[(29)]);
var inst_43300 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var inst_43301__$1 = cljs.core.keys(inst_43300);
var inst_43302 = cljs.core.count(inst_43301__$1);
var inst_43303 = (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,inst_43302) : cljs.core.reset_BANG_.call(null,dctr,inst_43302));
var inst_43308 = cljs.core.seq(inst_43301__$1);
var inst_43309 = inst_43308;
var inst_43310 = null;
var inst_43311 = (0);
var inst_43312 = (0);
var state_43369__$1 = (function (){var statearr_43412 = state_43369;
(statearr_43412[(10)] = inst_43310);

(statearr_43412[(11)] = inst_43312);

(statearr_43412[(20)] = inst_43311);

(statearr_43412[(30)] = inst_43303);

(statearr_43412[(21)] = inst_43309);

(statearr_43412[(29)] = inst_43301__$1);

return statearr_43412;
})();
var statearr_43413_43484 = state_43369__$1;
(statearr_43413_43484[(2)] = null);

(statearr_43413_43484[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (28))){
var inst_43328 = (state_43369[(25)]);
var inst_43309 = (state_43369[(21)]);
var inst_43328__$1 = cljs.core.seq(inst_43309);
var state_43369__$1 = (function (){var statearr_43414 = state_43369;
(statearr_43414[(25)] = inst_43328__$1);

return statearr_43414;
})();
if(inst_43328__$1){
var statearr_43415_43485 = state_43369__$1;
(statearr_43415_43485[(1)] = (33));

} else {
var statearr_43416_43486 = state_43369__$1;
(statearr_43416_43486[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (25))){
var inst_43312 = (state_43369[(11)]);
var inst_43311 = (state_43369[(20)]);
var inst_43314 = (inst_43312 < inst_43311);
var inst_43315 = inst_43314;
var state_43369__$1 = state_43369;
if(cljs.core.truth_(inst_43315)){
var statearr_43417_43487 = state_43369__$1;
(statearr_43417_43487[(1)] = (27));

} else {
var statearr_43418_43488 = state_43369__$1;
(statearr_43418_43488[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (34))){
var state_43369__$1 = state_43369;
var statearr_43419_43489 = state_43369__$1;
(statearr_43419_43489[(2)] = null);

(statearr_43419_43489[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (17))){
var state_43369__$1 = state_43369;
var statearr_43420_43490 = state_43369__$1;
(statearr_43420_43490[(2)] = null);

(statearr_43420_43490[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (3))){
var inst_43367 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
return cljs.core.async.impl.ioc_helpers.return_chan(state_43369__$1,inst_43367);
} else {
if((state_val_43370 === (12))){
var inst_43296 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43421_43491 = state_43369__$1;
(statearr_43421_43491[(2)] = inst_43296);

(statearr_43421_43491[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (2))){
var state_43369__$1 = state_43369;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_43369__$1,(4),ch);
} else {
if((state_val_43370 === (23))){
var state_43369__$1 = state_43369;
var statearr_43422_43492 = state_43369__$1;
(statearr_43422_43492[(2)] = null);

(statearr_43422_43492[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (35))){
var inst_43351 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43423_43493 = state_43369__$1;
(statearr_43423_43493[(2)] = inst_43351);

(statearr_43423_43493[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (19))){
var inst_43268 = (state_43369[(7)]);
var inst_43272 = cljs.core.chunk_first(inst_43268);
var inst_43273 = cljs.core.chunk_rest(inst_43268);
var inst_43274 = cljs.core.count(inst_43272);
var inst_43246 = inst_43273;
var inst_43247 = inst_43272;
var inst_43248 = inst_43274;
var inst_43249 = (0);
var state_43369__$1 = (function (){var statearr_43424 = state_43369;
(statearr_43424[(13)] = inst_43249);

(statearr_43424[(14)] = inst_43246);

(statearr_43424[(15)] = inst_43247);

(statearr_43424[(16)] = inst_43248);

return statearr_43424;
})();
var statearr_43425_43494 = state_43369__$1;
(statearr_43425_43494[(2)] = null);

(statearr_43425_43494[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (11))){
var inst_43246 = (state_43369[(14)]);
var inst_43268 = (state_43369[(7)]);
var inst_43268__$1 = cljs.core.seq(inst_43246);
var state_43369__$1 = (function (){var statearr_43426 = state_43369;
(statearr_43426[(7)] = inst_43268__$1);

return statearr_43426;
})();
if(inst_43268__$1){
var statearr_43427_43495 = state_43369__$1;
(statearr_43427_43495[(1)] = (16));

} else {
var statearr_43428_43496 = state_43369__$1;
(statearr_43428_43496[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (9))){
var inst_43298 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43429_43497 = state_43369__$1;
(statearr_43429_43497[(2)] = inst_43298);

(statearr_43429_43497[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (5))){
var inst_43244 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var inst_43245 = cljs.core.seq(inst_43244);
var inst_43246 = inst_43245;
var inst_43247 = null;
var inst_43248 = (0);
var inst_43249 = (0);
var state_43369__$1 = (function (){var statearr_43430 = state_43369;
(statearr_43430[(13)] = inst_43249);

(statearr_43430[(14)] = inst_43246);

(statearr_43430[(15)] = inst_43247);

(statearr_43430[(16)] = inst_43248);

return statearr_43430;
})();
var statearr_43431_43498 = state_43369__$1;
(statearr_43431_43498[(2)] = null);

(statearr_43431_43498[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (14))){
var state_43369__$1 = state_43369;
var statearr_43432_43499 = state_43369__$1;
(statearr_43432_43499[(2)] = null);

(statearr_43432_43499[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (45))){
var inst_43359 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43433_43500 = state_43369__$1;
(statearr_43433_43500[(2)] = inst_43359);

(statearr_43433_43500[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (26))){
var inst_43301 = (state_43369[(29)]);
var inst_43355 = (state_43369[(2)]);
var inst_43356 = cljs.core.seq(inst_43301);
var state_43369__$1 = (function (){var statearr_43434 = state_43369;
(statearr_43434[(31)] = inst_43355);

return statearr_43434;
})();
if(inst_43356){
var statearr_43435_43501 = state_43369__$1;
(statearr_43435_43501[(1)] = (42));

} else {
var statearr_43436_43502 = state_43369__$1;
(statearr_43436_43502[(1)] = (43));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (16))){
var inst_43268 = (state_43369[(7)]);
var inst_43270 = cljs.core.chunked_seq_QMARK_(inst_43268);
var state_43369__$1 = state_43369;
if(inst_43270){
var statearr_43437_43503 = state_43369__$1;
(statearr_43437_43503[(1)] = (19));

} else {
var statearr_43438_43504 = state_43369__$1;
(statearr_43438_43504[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (38))){
var inst_43348 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43439_43505 = state_43369__$1;
(statearr_43439_43505[(2)] = inst_43348);

(statearr_43439_43505[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (30))){
var state_43369__$1 = state_43369;
var statearr_43440_43506 = state_43369__$1;
(statearr_43440_43506[(2)] = null);

(statearr_43440_43506[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (10))){
var inst_43249 = (state_43369[(13)]);
var inst_43247 = (state_43369[(15)]);
var inst_43257 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_43247,inst_43249);
var inst_43258 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_43257,(0),null);
var inst_43259 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_43257,(1),null);
var state_43369__$1 = (function (){var statearr_43441 = state_43369;
(statearr_43441[(26)] = inst_43258);

return statearr_43441;
})();
if(cljs.core.truth_(inst_43259)){
var statearr_43442_43507 = state_43369__$1;
(statearr_43442_43507[(1)] = (13));

} else {
var statearr_43443_43508 = state_43369__$1;
(statearr_43443_43508[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (18))){
var inst_43294 = (state_43369[(2)]);
var state_43369__$1 = state_43369;
var statearr_43444_43509 = state_43369__$1;
(statearr_43444_43509[(2)] = inst_43294);

(statearr_43444_43509[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (42))){
var state_43369__$1 = state_43369;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_43369__$1,(45),dchan);
} else {
if((state_val_43370 === (37))){
var inst_43328 = (state_43369[(25)]);
var inst_43337 = (state_43369[(23)]);
var inst_43237 = (state_43369[(12)]);
var inst_43337__$1 = cljs.core.first(inst_43328);
var inst_43338 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_43337__$1,inst_43237,done);
var state_43369__$1 = (function (){var statearr_43445 = state_43369;
(statearr_43445[(23)] = inst_43337__$1);

return statearr_43445;
})();
if(cljs.core.truth_(inst_43338)){
var statearr_43446_43510 = state_43369__$1;
(statearr_43446_43510[(1)] = (39));

} else {
var statearr_43447_43511 = state_43369__$1;
(statearr_43447_43511[(1)] = (40));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43370 === (8))){
var inst_43249 = (state_43369[(13)]);
var inst_43248 = (state_43369[(16)]);
var inst_43251 = (inst_43249 < inst_43248);
var inst_43252 = inst_43251;
var state_43369__$1 = state_43369;
if(cljs.core.truth_(inst_43252)){
var statearr_43448_43512 = state_43369__$1;
(statearr_43448_43512[(1)] = (10));

} else {
var statearr_43449_43513 = state_43369__$1;
(statearr_43449_43513[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___43459,cs,m,dchan,dctr,done))
;
return ((function (switch__41984__auto__,c__42110__auto___43459,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__41985__auto__ = null;
var cljs$core$async$mult_$_state_machine__41985__auto____0 = (function (){
var statearr_43453 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_43453[(0)] = cljs$core$async$mult_$_state_machine__41985__auto__);

(statearr_43453[(1)] = (1));

return statearr_43453;
});
var cljs$core$async$mult_$_state_machine__41985__auto____1 = (function (state_43369){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_43369);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e43454){if((e43454 instanceof Object)){
var ex__41988__auto__ = e43454;
var statearr_43455_43514 = state_43369;
(statearr_43455_43514[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_43369);

return cljs.core.cst$kw$recur;
} else {
throw e43454;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__43515 = state_43369;
state_43369 = G__43515;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__41985__auto__ = function(state_43369){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__41985__auto____1.call(this,state_43369);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__41985__auto____0;
cljs$core$async$mult_$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__41985__auto____1;
return cljs$core$async$mult_$_state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___43459,cs,m,dchan,dctr,done))
})();
var state__42112__auto__ = (function (){var statearr_43456 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_43456[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___43459);

return statearr_43456;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___43459,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args43516 = [];
var len__10461__auto___43519 = arguments.length;
var i__10462__auto___43520 = (0);
while(true){
if((i__10462__auto___43520 < len__10461__auto___43519)){
args43516.push((arguments[i__10462__auto___43520]));

var G__43521 = (i__10462__auto___43520 + (1));
i__10462__auto___43520 = G__43521;
continue;
} else {
}
break;
}

var G__43518 = args43516.length;
switch (G__43518) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args43516.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__9991__auto__ = (((m == null))?null:m);
var m__9992__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__9992__auto__.call(null,m,ch));
} else {
var m__9992__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__9992__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__9991__auto__ = (((m == null))?null:m);
var m__9992__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__9992__auto__.call(null,m,ch));
} else {
var m__9992__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2(m,ch) : m__9992__auto____$1.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__9991__auto__ = (((m == null))?null:m);
var m__9992__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$1 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__9992__auto__.call(null,m));
} else {
var m__9992__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$1(m) : m__9992__auto____$1.call(null,m));
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__9991__auto__ = (((m == null))?null:m);
var m__9992__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__9992__auto__.call(null,m,state_map));
} else {
var m__9992__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__9992__auto____$1.call(null,m,state_map));
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__9991__auto__ = (((m == null))?null:m);
var m__9992__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__9992__auto__.call(null,m,mode));
} else {
var m__9992__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2(m,mode) : m__9992__auto____$1.call(null,m,mode));
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__10468__auto__ = [];
var len__10461__auto___43533 = arguments.length;
var i__10462__auto___43534 = (0);
while(true){
if((i__10462__auto___43534 < len__10461__auto___43533)){
args__10468__auto__.push((arguments[i__10462__auto___43534]));

var G__43535 = (i__10462__auto___43534 + (1));
i__10462__auto___43534 = G__43535;
continue;
} else {
}
break;
}

var argseq__10469__auto__ = ((((3) < args__10468__auto__.length))?(new cljs.core.IndexedSeq(args__10468__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__10469__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__43527){
var map__43528 = p__43527;
var map__43528__$1 = ((((!((map__43528 == null)))?((((map__43528.cljs$lang$protocol_mask$partition0$ & (64))) || (map__43528.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__43528):map__43528);
var opts = map__43528__$1;
var statearr_43530_43536 = state;
(statearr_43530_43536[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__6728__auto__ = cljs.core.async.do_alts(((function (map__43528,map__43528__$1,opts){
return (function (val){
var statearr_43531_43537 = state;
(statearr_43531_43537[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state);
});})(map__43528,map__43528__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__6728__auto__)){
var cb = temp__6728__auto__;
var statearr_43532_43538 = state;
(statearr_43532_43538[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cb) : cljs.core.deref.call(null,cb)));


return cljs.core.cst$kw$recur;
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq43523){
var G__43524 = cljs.core.first(seq43523);
var seq43523__$1 = cljs.core.next(seq43523);
var G__43525 = cljs.core.first(seq43523__$1);
var seq43523__$2 = cljs.core.next(seq43523__$1);
var G__43526 = cljs.core.first(seq43523__$2);
var seq43523__$3 = cljs.core.next(seq43523__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__43524,G__43525,G__43526,seq43523__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = (function (){var G__43708 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__43708) : cljs.core.atom.call(null,G__43708));
})();
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$pause,null,cljs.core.cst$kw$mute,null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,cljs.core.cst$kw$solo);
var solo_mode = (function (){var G__43709 = cljs.core.cst$kw$mute;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__43709) : cljs.core.atom.call(null,G__43709));
})();
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv(((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_((attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(v) : attr.call(null,v)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(cs) : cljs.core.deref.call(null,cs));
var mode = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(solo_mode) : cljs.core.deref.call(null,solo_mode));
var solos = pick(cljs.core.cst$kw$solo,chs);
var pauses = pick(cljs.core.cst$kw$pause,chs);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$solos,solos,cljs.core.cst$kw$mutes,pick(cljs.core.cst$kw$mute,chs),cljs.core.cst$kw$reads,cljs.core.conj.cljs$core$IFn$_invoke$arity$2((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,cljs.core.cst$kw$pause)) && (!(cljs.core.empty_QMARK_(solos))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async43710 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async43710 = (function (change,mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta43711){
this.change = change;
this.mix = mix;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta43711 = meta43711;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_43712,meta43711__$1){
var self__ = this;
var _43712__$1 = this;
return (new cljs.core.async.t_cljs$core$async43710(self__.change,self__.mix,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta43711__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_43712){
var self__ = this;
var _43712__$1 = this;
return self__.meta43711;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$async$Mix$ = true;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__43713_43877 = self__.cs;
var G__43714_43878 = cljs.core.PersistentArrayMap.EMPTY;
(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__43713_43877,G__43714_43878) : cljs.core.reset_BANG_.call(null,G__43713_43877,G__43714_43878));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(mode) : self__.solo_modes.call(null,mode)))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str("(solo-modes mode)")].join('')));
}

(cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(self__.solo_mode,mode) : cljs.core.reset_BANG_.call(null,self__.solo_mode,mode));

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$change,cljs.core.with_meta(cljs.core.cst$sym$mix,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$out], null))),cljs.core.cst$kw$doc,"Creates and returns a mix of one or more input channels which will\n  be put on the supplied out channel. Input sources can be added to\n  the mix with 'admix', and removed with 'unmix'. A mix supports\n  soloing, muting and pausing multiple inputs atomically using\n  'toggle', and can solo using either muting or pausing as determined\n  by 'solo-mode'.\n\n  Each channel can have zero or more boolean modes set via 'toggle':\n\n  :solo - when true, only this (ond other soloed) channel(s) will appear\n          in the mix output channel. :mute and :pause states of soloed\n          channels are ignored. If solo-mode is :mute, non-soloed\n          channels are muted, if :pause, non-soloed channels are\n          paused.\n\n  :mute - muted channels will have their contents consumed but not included in the mix\n  :pause - paused channels will not have their contents consumed (and thus also not included in the mix)\n"], null)),cljs.core.cst$sym$solo_DASH_mode,cljs.core.cst$sym$pick,cljs.core.cst$sym$cs,cljs.core.cst$sym$calc_DASH_state,cljs.core.cst$sym$out,cljs.core.cst$sym$changed,cljs.core.cst$sym$solo_DASH_modes,cljs.core.cst$sym$attrs,cljs.core.cst$sym$meta43711], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async43710.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async43710.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async43710";

cljs.core.async.t_cljs$core$async43710.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async43710");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async43710 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async43710(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta43711){
return (new cljs.core.async.t_cljs$core$async43710(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta43711));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async43710(change,cljs$core$async$mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__42110__auto___43879 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___43879,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___43879,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_43814){
var state_val_43815 = (state_43814[(1)]);
if((state_val_43815 === (7))){
var inst_43730 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
var statearr_43816_43880 = state_43814__$1;
(statearr_43816_43880[(2)] = inst_43730);

(statearr_43816_43880[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (20))){
var inst_43742 = (state_43814[(7)]);
var state_43814__$1 = state_43814;
var statearr_43817_43881 = state_43814__$1;
(statearr_43817_43881[(2)] = inst_43742);

(statearr_43817_43881[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (27))){
var state_43814__$1 = state_43814;
var statearr_43818_43882 = state_43814__$1;
(statearr_43818_43882[(2)] = null);

(statearr_43818_43882[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (1))){
var inst_43718 = (state_43814[(8)]);
var inst_43718__$1 = calc_state();
var inst_43720 = (inst_43718__$1 == null);
var inst_43721 = cljs.core.not(inst_43720);
var state_43814__$1 = (function (){var statearr_43819 = state_43814;
(statearr_43819[(8)] = inst_43718__$1);

return statearr_43819;
})();
if(inst_43721){
var statearr_43820_43883 = state_43814__$1;
(statearr_43820_43883[(1)] = (2));

} else {
var statearr_43821_43884 = state_43814__$1;
(statearr_43821_43884[(1)] = (3));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (24))){
var inst_43765 = (state_43814[(9)]);
var inst_43774 = (state_43814[(10)]);
var inst_43788 = (state_43814[(11)]);
var inst_43788__$1 = (inst_43765.cljs$core$IFn$_invoke$arity$1 ? inst_43765.cljs$core$IFn$_invoke$arity$1(inst_43774) : inst_43765.call(null,inst_43774));
var state_43814__$1 = (function (){var statearr_43822 = state_43814;
(statearr_43822[(11)] = inst_43788__$1);

return statearr_43822;
})();
if(cljs.core.truth_(inst_43788__$1)){
var statearr_43823_43885 = state_43814__$1;
(statearr_43823_43885[(1)] = (29));

} else {
var statearr_43824_43886 = state_43814__$1;
(statearr_43824_43886[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (4))){
var inst_43733 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
if(cljs.core.truth_(inst_43733)){
var statearr_43825_43887 = state_43814__$1;
(statearr_43825_43887[(1)] = (8));

} else {
var statearr_43826_43888 = state_43814__$1;
(statearr_43826_43888[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (15))){
var inst_43759 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
if(cljs.core.truth_(inst_43759)){
var statearr_43827_43889 = state_43814__$1;
(statearr_43827_43889[(1)] = (19));

} else {
var statearr_43828_43890 = state_43814__$1;
(statearr_43828_43890[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (21))){
var inst_43764 = (state_43814[(12)]);
var inst_43764__$1 = (state_43814[(2)]);
var inst_43765 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_43764__$1,cljs.core.cst$kw$solos);
var inst_43766 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_43764__$1,cljs.core.cst$kw$mutes);
var inst_43767 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_43764__$1,cljs.core.cst$kw$reads);
var state_43814__$1 = (function (){var statearr_43829 = state_43814;
(statearr_43829[(13)] = inst_43766);

(statearr_43829[(9)] = inst_43765);

(statearr_43829[(12)] = inst_43764__$1);

return statearr_43829;
})();
return cljs.core.async.ioc_alts_BANG_(state_43814__$1,(22),inst_43767);
} else {
if((state_val_43815 === (31))){
var inst_43796 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
if(cljs.core.truth_(inst_43796)){
var statearr_43830_43891 = state_43814__$1;
(statearr_43830_43891[(1)] = (32));

} else {
var statearr_43831_43892 = state_43814__$1;
(statearr_43831_43892[(1)] = (33));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (32))){
var inst_43773 = (state_43814[(14)]);
var state_43814__$1 = state_43814;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_43814__$1,(35),out,inst_43773);
} else {
if((state_val_43815 === (33))){
var inst_43764 = (state_43814[(12)]);
var inst_43742 = inst_43764;
var state_43814__$1 = (function (){var statearr_43832 = state_43814;
(statearr_43832[(7)] = inst_43742);

return statearr_43832;
})();
var statearr_43833_43893 = state_43814__$1;
(statearr_43833_43893[(2)] = null);

(statearr_43833_43893[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (13))){
var inst_43742 = (state_43814[(7)]);
var inst_43749 = inst_43742.cljs$lang$protocol_mask$partition0$;
var inst_43750 = (inst_43749 & (64));
var inst_43751 = inst_43742.cljs$core$ISeq$;
var inst_43752 = (inst_43750) || (inst_43751);
var state_43814__$1 = state_43814;
if(cljs.core.truth_(inst_43752)){
var statearr_43834_43894 = state_43814__$1;
(statearr_43834_43894[(1)] = (16));

} else {
var statearr_43835_43895 = state_43814__$1;
(statearr_43835_43895[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (22))){
var inst_43773 = (state_43814[(14)]);
var inst_43774 = (state_43814[(10)]);
var inst_43772 = (state_43814[(2)]);
var inst_43773__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_43772,(0),null);
var inst_43774__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_43772,(1),null);
var inst_43775 = (inst_43773__$1 == null);
var inst_43776 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_43774__$1,change);
var inst_43777 = (inst_43775) || (inst_43776);
var state_43814__$1 = (function (){var statearr_43836 = state_43814;
(statearr_43836[(14)] = inst_43773__$1);

(statearr_43836[(10)] = inst_43774__$1);

return statearr_43836;
})();
if(cljs.core.truth_(inst_43777)){
var statearr_43837_43896 = state_43814__$1;
(statearr_43837_43896[(1)] = (23));

} else {
var statearr_43838_43897 = state_43814__$1;
(statearr_43838_43897[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (36))){
var inst_43764 = (state_43814[(12)]);
var inst_43742 = inst_43764;
var state_43814__$1 = (function (){var statearr_43839 = state_43814;
(statearr_43839[(7)] = inst_43742);

return statearr_43839;
})();
var statearr_43840_43898 = state_43814__$1;
(statearr_43840_43898[(2)] = null);

(statearr_43840_43898[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (29))){
var inst_43788 = (state_43814[(11)]);
var state_43814__$1 = state_43814;
var statearr_43841_43899 = state_43814__$1;
(statearr_43841_43899[(2)] = inst_43788);

(statearr_43841_43899[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (6))){
var state_43814__$1 = state_43814;
var statearr_43842_43900 = state_43814__$1;
(statearr_43842_43900[(2)] = false);

(statearr_43842_43900[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (28))){
var inst_43784 = (state_43814[(2)]);
var inst_43785 = calc_state();
var inst_43742 = inst_43785;
var state_43814__$1 = (function (){var statearr_43843 = state_43814;
(statearr_43843[(15)] = inst_43784);

(statearr_43843[(7)] = inst_43742);

return statearr_43843;
})();
var statearr_43844_43901 = state_43814__$1;
(statearr_43844_43901[(2)] = null);

(statearr_43844_43901[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (25))){
var inst_43810 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
var statearr_43845_43902 = state_43814__$1;
(statearr_43845_43902[(2)] = inst_43810);

(statearr_43845_43902[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (34))){
var inst_43808 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
var statearr_43846_43903 = state_43814__$1;
(statearr_43846_43903[(2)] = inst_43808);

(statearr_43846_43903[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (17))){
var state_43814__$1 = state_43814;
var statearr_43847_43904 = state_43814__$1;
(statearr_43847_43904[(2)] = false);

(statearr_43847_43904[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (3))){
var state_43814__$1 = state_43814;
var statearr_43848_43905 = state_43814__$1;
(statearr_43848_43905[(2)] = false);

(statearr_43848_43905[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (12))){
var inst_43812 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
return cljs.core.async.impl.ioc_helpers.return_chan(state_43814__$1,inst_43812);
} else {
if((state_val_43815 === (2))){
var inst_43718 = (state_43814[(8)]);
var inst_43723 = inst_43718.cljs$lang$protocol_mask$partition0$;
var inst_43724 = (inst_43723 & (64));
var inst_43725 = inst_43718.cljs$core$ISeq$;
var inst_43726 = (inst_43724) || (inst_43725);
var state_43814__$1 = state_43814;
if(cljs.core.truth_(inst_43726)){
var statearr_43849_43906 = state_43814__$1;
(statearr_43849_43906[(1)] = (5));

} else {
var statearr_43850_43907 = state_43814__$1;
(statearr_43850_43907[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (23))){
var inst_43773 = (state_43814[(14)]);
var inst_43779 = (inst_43773 == null);
var state_43814__$1 = state_43814;
if(cljs.core.truth_(inst_43779)){
var statearr_43851_43908 = state_43814__$1;
(statearr_43851_43908[(1)] = (26));

} else {
var statearr_43852_43909 = state_43814__$1;
(statearr_43852_43909[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (35))){
var inst_43799 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
if(cljs.core.truth_(inst_43799)){
var statearr_43853_43910 = state_43814__$1;
(statearr_43853_43910[(1)] = (36));

} else {
var statearr_43854_43911 = state_43814__$1;
(statearr_43854_43911[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (19))){
var inst_43742 = (state_43814[(7)]);
var inst_43761 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_43742);
var state_43814__$1 = state_43814;
var statearr_43855_43912 = state_43814__$1;
(statearr_43855_43912[(2)] = inst_43761);

(statearr_43855_43912[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (11))){
var inst_43742 = (state_43814[(7)]);
var inst_43746 = (inst_43742 == null);
var inst_43747 = cljs.core.not(inst_43746);
var state_43814__$1 = state_43814;
if(inst_43747){
var statearr_43856_43913 = state_43814__$1;
(statearr_43856_43913[(1)] = (13));

} else {
var statearr_43857_43914 = state_43814__$1;
(statearr_43857_43914[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (9))){
var inst_43718 = (state_43814[(8)]);
var state_43814__$1 = state_43814;
var statearr_43858_43915 = state_43814__$1;
(statearr_43858_43915[(2)] = inst_43718);

(statearr_43858_43915[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (5))){
var state_43814__$1 = state_43814;
var statearr_43859_43916 = state_43814__$1;
(statearr_43859_43916[(2)] = true);

(statearr_43859_43916[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (14))){
var state_43814__$1 = state_43814;
var statearr_43860_43917 = state_43814__$1;
(statearr_43860_43917[(2)] = false);

(statearr_43860_43917[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (26))){
var inst_43774 = (state_43814[(10)]);
var inst_43781 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_43774);
var state_43814__$1 = state_43814;
var statearr_43861_43918 = state_43814__$1;
(statearr_43861_43918[(2)] = inst_43781);

(statearr_43861_43918[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (16))){
var state_43814__$1 = state_43814;
var statearr_43862_43919 = state_43814__$1;
(statearr_43862_43919[(2)] = true);

(statearr_43862_43919[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (38))){
var inst_43804 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
var statearr_43863_43920 = state_43814__$1;
(statearr_43863_43920[(2)] = inst_43804);

(statearr_43863_43920[(1)] = (34));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (30))){
var inst_43766 = (state_43814[(13)]);
var inst_43765 = (state_43814[(9)]);
var inst_43774 = (state_43814[(10)]);
var inst_43791 = cljs.core.empty_QMARK_(inst_43765);
var inst_43792 = (inst_43766.cljs$core$IFn$_invoke$arity$1 ? inst_43766.cljs$core$IFn$_invoke$arity$1(inst_43774) : inst_43766.call(null,inst_43774));
var inst_43793 = cljs.core.not(inst_43792);
var inst_43794 = (inst_43791) && (inst_43793);
var state_43814__$1 = state_43814;
var statearr_43864_43921 = state_43814__$1;
(statearr_43864_43921[(2)] = inst_43794);

(statearr_43864_43921[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (10))){
var inst_43718 = (state_43814[(8)]);
var inst_43738 = (state_43814[(2)]);
var inst_43739 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_43738,cljs.core.cst$kw$solos);
var inst_43740 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_43738,cljs.core.cst$kw$mutes);
var inst_43741 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_43738,cljs.core.cst$kw$reads);
var inst_43742 = inst_43718;
var state_43814__$1 = (function (){var statearr_43865 = state_43814;
(statearr_43865[(16)] = inst_43740);

(statearr_43865[(7)] = inst_43742);

(statearr_43865[(17)] = inst_43739);

(statearr_43865[(18)] = inst_43741);

return statearr_43865;
})();
var statearr_43866_43922 = state_43814__$1;
(statearr_43866_43922[(2)] = null);

(statearr_43866_43922[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (18))){
var inst_43756 = (state_43814[(2)]);
var state_43814__$1 = state_43814;
var statearr_43867_43923 = state_43814__$1;
(statearr_43867_43923[(2)] = inst_43756);

(statearr_43867_43923[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (37))){
var state_43814__$1 = state_43814;
var statearr_43868_43924 = state_43814__$1;
(statearr_43868_43924[(2)] = null);

(statearr_43868_43924[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_43815 === (8))){
var inst_43718 = (state_43814[(8)]);
var inst_43735 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_43718);
var state_43814__$1 = state_43814;
var statearr_43869_43925 = state_43814__$1;
(statearr_43869_43925[(2)] = inst_43735);

(statearr_43869_43925[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___43879,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__41984__auto__,c__42110__auto___43879,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__41985__auto__ = null;
var cljs$core$async$mix_$_state_machine__41985__auto____0 = (function (){
var statearr_43873 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_43873[(0)] = cljs$core$async$mix_$_state_machine__41985__auto__);

(statearr_43873[(1)] = (1));

return statearr_43873;
});
var cljs$core$async$mix_$_state_machine__41985__auto____1 = (function (state_43814){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_43814);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e43874){if((e43874 instanceof Object)){
var ex__41988__auto__ = e43874;
var statearr_43875_43926 = state_43814;
(statearr_43875_43926[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_43814);

return cljs.core.cst$kw$recur;
} else {
throw e43874;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__43927 = state_43814;
state_43814 = G__43927;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__41985__auto__ = function(state_43814){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__41985__auto____1.call(this,state_43814);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__41985__auto____0;
cljs$core$async$mix_$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__41985__auto____1;
return cljs$core$async$mix_$_state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___43879,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__42112__auto__ = (function (){var statearr_43876 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_43876[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___43879);

return statearr_43876;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___43879,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__9991__auto__ = (((p == null))?null:p);
var m__9992__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$4 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__9992__auto__.call(null,p,v,ch,close_QMARK_));
} else {
var m__9992__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$4 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__9992__auto____$1.call(null,p,v,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__9991__auto__ = (((p == null))?null:p);
var m__9992__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$3 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__9992__auto__.call(null,p,v,ch));
} else {
var m__9992__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$3 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__9992__auto____$1.call(null,p,v,ch));
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args43928 = [];
var len__10461__auto___43931 = arguments.length;
var i__10462__auto___43932 = (0);
while(true){
if((i__10462__auto___43932 < len__10461__auto___43931)){
args43928.push((arguments[i__10462__auto___43932]));

var G__43933 = (i__10462__auto___43932 + (1));
i__10462__auto___43932 = G__43933;
continue;
} else {
}
break;
}

var G__43930 = args43928.length;
switch (G__43930) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args43928.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__9991__auto__ = (((p == null))?null:p);
var m__9992__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$1 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__9992__auto__.call(null,p));
} else {
var m__9992__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$1(p) : m__9992__auto____$1.call(null,p));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__9991__auto__ = (((p == null))?null:p);
var m__9992__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__9991__auto__)]);
if(!((m__9992__auto__ == null))){
return (m__9992__auto__.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__9992__auto__.call(null,p,v));
} else {
var m__9992__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__9992__auto____$1 == null))){
return (m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2 ? m__9992__auto____$1.cljs$core$IFn$_invoke$arity$2(p,v) : m__9992__auto____$1.call(null,p,v));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args43936 = [];
var len__10461__auto___44064 = arguments.length;
var i__10462__auto___44065 = (0);
while(true){
if((i__10462__auto___44065 < len__10461__auto___44064)){
args43936.push((arguments[i__10462__auto___44065]));

var G__44066 = (i__10462__auto___44065 + (1));
i__10462__auto___44065 = G__44066;
continue;
} else {
}
break;
}

var G__43938 = args43936.length;
switch (G__43938) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args43936.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = (function (){var G__43939 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(G__43939) : cljs.core.atom.call(null,G__43939));
})();
var ensure_mult = ((function (mults){
return (function (topic){
var or__9278__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults)),topic);
if(cljs.core.truth_(or__9278__auto__)){
return or__9278__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,((function (or__9278__auto__,mults){
return (function (p1__43935_SHARP_){
if(cljs.core.truth_((p1__43935_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__43935_SHARP_.cljs$core$IFn$_invoke$arity$1(topic) : p1__43935_SHARP_.call(null,topic)))){
return p1__43935_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__43935_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(topic) : buf_fn.call(null,topic)))));
}
});})(or__9278__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async43940 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async43940 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta43941){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta43941 = meta43941;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_43942,meta43941__$1){
var self__ = this;
var _43942__$1 = this;
return (new cljs.core.async.t_cljs$core$async43940(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta43941__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_43942){
var self__ = this;
var _43942__$1 = this;
return self__.meta43941;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$async$Pub$ = true;

cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(topic) : self__.ensure_mult.call(null,topic));
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__6728__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(self__.mults) : cljs.core.deref.call(null,self__.mults)),topic);
if(cljs.core.truth_(temp__6728__auto__)){
var m = temp__6728__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
var G__43943 = self__.mults;
var G__43944 = cljs.core.PersistentArrayMap.EMPTY;
return (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(G__43943,G__43944) : cljs.core.reset_BANG_.call(null,G__43943,G__43944));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async43940.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async43940.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch,cljs.core.cst$sym$topic_DASH_fn,cljs.core.cst$sym$buf_DASH_fn,cljs.core.cst$sym$mults,cljs.core.cst$sym$ensure_DASH_mult,cljs.core.cst$sym$meta43941], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async43940.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async43940.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async43940";

cljs.core.async.t_cljs$core$async43940.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async43940");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async43940 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async43940(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta43941){
return (new cljs.core.async.t_cljs$core$async43940(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta43941));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async43940(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__42110__auto___44068 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___44068,mults,ensure_mult,p){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___44068,mults,ensure_mult,p){
return (function (state_44016){
var state_val_44017 = (state_44016[(1)]);
if((state_val_44017 === (7))){
var inst_44012 = (state_44016[(2)]);
var state_44016__$1 = state_44016;
var statearr_44018_44069 = state_44016__$1;
(statearr_44018_44069[(2)] = inst_44012);

(statearr_44018_44069[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (20))){
var state_44016__$1 = state_44016;
var statearr_44019_44070 = state_44016__$1;
(statearr_44019_44070[(2)] = null);

(statearr_44019_44070[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (1))){
var state_44016__$1 = state_44016;
var statearr_44020_44071 = state_44016__$1;
(statearr_44020_44071[(2)] = null);

(statearr_44020_44071[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (24))){
var inst_43995 = (state_44016[(7)]);
var inst_44004 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_43995);
var state_44016__$1 = state_44016;
var statearr_44021_44072 = state_44016__$1;
(statearr_44021_44072[(2)] = inst_44004);

(statearr_44021_44072[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (4))){
var inst_43947 = (state_44016[(8)]);
var inst_43947__$1 = (state_44016[(2)]);
var inst_43948 = (inst_43947__$1 == null);
var state_44016__$1 = (function (){var statearr_44022 = state_44016;
(statearr_44022[(8)] = inst_43947__$1);

return statearr_44022;
})();
if(cljs.core.truth_(inst_43948)){
var statearr_44023_44073 = state_44016__$1;
(statearr_44023_44073[(1)] = (5));

} else {
var statearr_44024_44074 = state_44016__$1;
(statearr_44024_44074[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (15))){
var inst_43989 = (state_44016[(2)]);
var state_44016__$1 = state_44016;
var statearr_44025_44075 = state_44016__$1;
(statearr_44025_44075[(2)] = inst_43989);

(statearr_44025_44075[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (21))){
var inst_44009 = (state_44016[(2)]);
var state_44016__$1 = (function (){var statearr_44026 = state_44016;
(statearr_44026[(9)] = inst_44009);

return statearr_44026;
})();
var statearr_44027_44076 = state_44016__$1;
(statearr_44027_44076[(2)] = null);

(statearr_44027_44076[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (13))){
var inst_43971 = (state_44016[(10)]);
var inst_43973 = cljs.core.chunked_seq_QMARK_(inst_43971);
var state_44016__$1 = state_44016;
if(inst_43973){
var statearr_44028_44077 = state_44016__$1;
(statearr_44028_44077[(1)] = (16));

} else {
var statearr_44029_44078 = state_44016__$1;
(statearr_44029_44078[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (22))){
var inst_44001 = (state_44016[(2)]);
var state_44016__$1 = state_44016;
if(cljs.core.truth_(inst_44001)){
var statearr_44030_44079 = state_44016__$1;
(statearr_44030_44079[(1)] = (23));

} else {
var statearr_44031_44080 = state_44016__$1;
(statearr_44031_44080[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (6))){
var inst_43947 = (state_44016[(8)]);
var inst_43997 = (state_44016[(11)]);
var inst_43995 = (state_44016[(7)]);
var inst_43995__$1 = (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(inst_43947) : topic_fn.call(null,inst_43947));
var inst_43996 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults));
var inst_43997__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_43996,inst_43995__$1);
var state_44016__$1 = (function (){var statearr_44032 = state_44016;
(statearr_44032[(11)] = inst_43997__$1);

(statearr_44032[(7)] = inst_43995__$1);

return statearr_44032;
})();
if(cljs.core.truth_(inst_43997__$1)){
var statearr_44033_44081 = state_44016__$1;
(statearr_44033_44081[(1)] = (19));

} else {
var statearr_44034_44082 = state_44016__$1;
(statearr_44034_44082[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (25))){
var inst_44006 = (state_44016[(2)]);
var state_44016__$1 = state_44016;
var statearr_44035_44083 = state_44016__$1;
(statearr_44035_44083[(2)] = inst_44006);

(statearr_44035_44083[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (17))){
var inst_43971 = (state_44016[(10)]);
var inst_43980 = cljs.core.first(inst_43971);
var inst_43981 = cljs.core.async.muxch_STAR_(inst_43980);
var inst_43982 = cljs.core.async.close_BANG_(inst_43981);
var inst_43983 = cljs.core.next(inst_43971);
var inst_43957 = inst_43983;
var inst_43958 = null;
var inst_43959 = (0);
var inst_43960 = (0);
var state_44016__$1 = (function (){var statearr_44036 = state_44016;
(statearr_44036[(12)] = inst_43958);

(statearr_44036[(13)] = inst_43982);

(statearr_44036[(14)] = inst_43957);

(statearr_44036[(15)] = inst_43959);

(statearr_44036[(16)] = inst_43960);

return statearr_44036;
})();
var statearr_44037_44084 = state_44016__$1;
(statearr_44037_44084[(2)] = null);

(statearr_44037_44084[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (3))){
var inst_44014 = (state_44016[(2)]);
var state_44016__$1 = state_44016;
return cljs.core.async.impl.ioc_helpers.return_chan(state_44016__$1,inst_44014);
} else {
if((state_val_44017 === (12))){
var inst_43991 = (state_44016[(2)]);
var state_44016__$1 = state_44016;
var statearr_44038_44085 = state_44016__$1;
(statearr_44038_44085[(2)] = inst_43991);

(statearr_44038_44085[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (2))){
var state_44016__$1 = state_44016;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_44016__$1,(4),ch);
} else {
if((state_val_44017 === (23))){
var state_44016__$1 = state_44016;
var statearr_44039_44086 = state_44016__$1;
(statearr_44039_44086[(2)] = null);

(statearr_44039_44086[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (19))){
var inst_43947 = (state_44016[(8)]);
var inst_43997 = (state_44016[(11)]);
var inst_43999 = cljs.core.async.muxch_STAR_(inst_43997);
var state_44016__$1 = state_44016;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44016__$1,(22),inst_43999,inst_43947);
} else {
if((state_val_44017 === (11))){
var inst_43957 = (state_44016[(14)]);
var inst_43971 = (state_44016[(10)]);
var inst_43971__$1 = cljs.core.seq(inst_43957);
var state_44016__$1 = (function (){var statearr_44040 = state_44016;
(statearr_44040[(10)] = inst_43971__$1);

return statearr_44040;
})();
if(inst_43971__$1){
var statearr_44041_44087 = state_44016__$1;
(statearr_44041_44087[(1)] = (13));

} else {
var statearr_44042_44088 = state_44016__$1;
(statearr_44042_44088[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (9))){
var inst_43993 = (state_44016[(2)]);
var state_44016__$1 = state_44016;
var statearr_44043_44089 = state_44016__$1;
(statearr_44043_44089[(2)] = inst_43993);

(statearr_44043_44089[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (5))){
var inst_43954 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(mults) : cljs.core.deref.call(null,mults));
var inst_43955 = cljs.core.vals(inst_43954);
var inst_43956 = cljs.core.seq(inst_43955);
var inst_43957 = inst_43956;
var inst_43958 = null;
var inst_43959 = (0);
var inst_43960 = (0);
var state_44016__$1 = (function (){var statearr_44044 = state_44016;
(statearr_44044[(12)] = inst_43958);

(statearr_44044[(14)] = inst_43957);

(statearr_44044[(15)] = inst_43959);

(statearr_44044[(16)] = inst_43960);

return statearr_44044;
})();
var statearr_44045_44090 = state_44016__$1;
(statearr_44045_44090[(2)] = null);

(statearr_44045_44090[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (14))){
var state_44016__$1 = state_44016;
var statearr_44049_44091 = state_44016__$1;
(statearr_44049_44091[(2)] = null);

(statearr_44049_44091[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (16))){
var inst_43971 = (state_44016[(10)]);
var inst_43975 = cljs.core.chunk_first(inst_43971);
var inst_43976 = cljs.core.chunk_rest(inst_43971);
var inst_43977 = cljs.core.count(inst_43975);
var inst_43957 = inst_43976;
var inst_43958 = inst_43975;
var inst_43959 = inst_43977;
var inst_43960 = (0);
var state_44016__$1 = (function (){var statearr_44050 = state_44016;
(statearr_44050[(12)] = inst_43958);

(statearr_44050[(14)] = inst_43957);

(statearr_44050[(15)] = inst_43959);

(statearr_44050[(16)] = inst_43960);

return statearr_44050;
})();
var statearr_44051_44092 = state_44016__$1;
(statearr_44051_44092[(2)] = null);

(statearr_44051_44092[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (10))){
var inst_43958 = (state_44016[(12)]);
var inst_43957 = (state_44016[(14)]);
var inst_43959 = (state_44016[(15)]);
var inst_43960 = (state_44016[(16)]);
var inst_43965 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_43958,inst_43960);
var inst_43966 = cljs.core.async.muxch_STAR_(inst_43965);
var inst_43967 = cljs.core.async.close_BANG_(inst_43966);
var inst_43968 = (inst_43960 + (1));
var tmp44046 = inst_43958;
var tmp44047 = inst_43957;
var tmp44048 = inst_43959;
var inst_43957__$1 = tmp44047;
var inst_43958__$1 = tmp44046;
var inst_43959__$1 = tmp44048;
var inst_43960__$1 = inst_43968;
var state_44016__$1 = (function (){var statearr_44052 = state_44016;
(statearr_44052[(12)] = inst_43958__$1);

(statearr_44052[(14)] = inst_43957__$1);

(statearr_44052[(15)] = inst_43959__$1);

(statearr_44052[(16)] = inst_43960__$1);

(statearr_44052[(17)] = inst_43967);

return statearr_44052;
})();
var statearr_44053_44093 = state_44016__$1;
(statearr_44053_44093[(2)] = null);

(statearr_44053_44093[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (18))){
var inst_43986 = (state_44016[(2)]);
var state_44016__$1 = state_44016;
var statearr_44054_44094 = state_44016__$1;
(statearr_44054_44094[(2)] = inst_43986);

(statearr_44054_44094[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44017 === (8))){
var inst_43959 = (state_44016[(15)]);
var inst_43960 = (state_44016[(16)]);
var inst_43962 = (inst_43960 < inst_43959);
var inst_43963 = inst_43962;
var state_44016__$1 = state_44016;
if(cljs.core.truth_(inst_43963)){
var statearr_44055_44095 = state_44016__$1;
(statearr_44055_44095[(1)] = (10));

} else {
var statearr_44056_44096 = state_44016__$1;
(statearr_44056_44096[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___44068,mults,ensure_mult,p))
;
return ((function (switch__41984__auto__,c__42110__auto___44068,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_44060 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_44060[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_44060[(1)] = (1));

return statearr_44060;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_44016){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44016);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44061){if((e44061 instanceof Object)){
var ex__41988__auto__ = e44061;
var statearr_44062_44097 = state_44016;
(statearr_44062_44097[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44016);

return cljs.core.cst$kw$recur;
} else {
throw e44061;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44098 = state_44016;
state_44016 = G__44098;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_44016){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_44016);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___44068,mults,ensure_mult,p))
})();
var state__42112__auto__ = (function (){var statearr_44063 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44063[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___44068);

return statearr_44063;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___44068,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args44099 = [];
var len__10461__auto___44102 = arguments.length;
var i__10462__auto___44103 = (0);
while(true){
if((i__10462__auto___44103 < len__10461__auto___44102)){
args44099.push((arguments[i__10462__auto___44103]));

var G__44104 = (i__10462__auto___44103 + (1));
i__10462__auto___44103 = G__44104;
continue;
} else {
}
break;
}

var G__44101 = args44099.length;
switch (G__44101) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44099.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args44106 = [];
var len__10461__auto___44109 = arguments.length;
var i__10462__auto___44110 = (0);
while(true){
if((i__10462__auto___44110 < len__10461__auto___44109)){
args44106.push((arguments[i__10462__auto___44110]));

var G__44111 = (i__10462__auto___44110 + (1));
i__10462__auto___44110 = G__44111;
continue;
} else {
}
break;
}

var G__44108 = args44106.length;
switch (G__44108) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44106.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1(p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2(p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args44113 = [];
var len__10461__auto___44184 = arguments.length;
var i__10462__auto___44185 = (0);
while(true){
if((i__10462__auto___44185 < len__10461__auto___44184)){
args44113.push((arguments[i__10462__auto___44185]));

var G__44186 = (i__10462__auto___44185 + (1));
i__10462__auto___44185 = G__44186;
continue;
} else {
}
break;
}

var G__44115 = args44113.length;
switch (G__44115) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44113.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = (cljs.core.atom.cljs$core$IFn$_invoke$arity$1 ? cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null) : cljs.core.atom.call(null,null));
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
var c__42110__auto___44188 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___44188,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___44188,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_44154){
var state_val_44155 = (state_44154[(1)]);
if((state_val_44155 === (7))){
var state_44154__$1 = state_44154;
var statearr_44156_44189 = state_44154__$1;
(statearr_44156_44189[(2)] = null);

(statearr_44156_44189[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (1))){
var state_44154__$1 = state_44154;
var statearr_44157_44190 = state_44154__$1;
(statearr_44157_44190[(2)] = null);

(statearr_44157_44190[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (4))){
var inst_44118 = (state_44154[(7)]);
var inst_44120 = (inst_44118 < cnt);
var state_44154__$1 = state_44154;
if(cljs.core.truth_(inst_44120)){
var statearr_44158_44191 = state_44154__$1;
(statearr_44158_44191[(1)] = (6));

} else {
var statearr_44159_44192 = state_44154__$1;
(statearr_44159_44192[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (15))){
var inst_44150 = (state_44154[(2)]);
var state_44154__$1 = state_44154;
var statearr_44160_44193 = state_44154__$1;
(statearr_44160_44193[(2)] = inst_44150);

(statearr_44160_44193[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (13))){
var inst_44143 = cljs.core.async.close_BANG_(out);
var state_44154__$1 = state_44154;
var statearr_44161_44194 = state_44154__$1;
(statearr_44161_44194[(2)] = inst_44143);

(statearr_44161_44194[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (6))){
var state_44154__$1 = state_44154;
var statearr_44162_44195 = state_44154__$1;
(statearr_44162_44195[(2)] = null);

(statearr_44162_44195[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (3))){
var inst_44152 = (state_44154[(2)]);
var state_44154__$1 = state_44154;
return cljs.core.async.impl.ioc_helpers.return_chan(state_44154__$1,inst_44152);
} else {
if((state_val_44155 === (12))){
var inst_44140 = (state_44154[(8)]);
var inst_44140__$1 = (state_44154[(2)]);
var inst_44141 = cljs.core.some(cljs.core.nil_QMARK_,inst_44140__$1);
var state_44154__$1 = (function (){var statearr_44163 = state_44154;
(statearr_44163[(8)] = inst_44140__$1);

return statearr_44163;
})();
if(cljs.core.truth_(inst_44141)){
var statearr_44164_44196 = state_44154__$1;
(statearr_44164_44196[(1)] = (13));

} else {
var statearr_44165_44197 = state_44154__$1;
(statearr_44165_44197[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (2))){
var inst_44117 = (cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2 ? cljs.core.reset_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cnt) : cljs.core.reset_BANG_.call(null,dctr,cnt));
var inst_44118 = (0);
var state_44154__$1 = (function (){var statearr_44166 = state_44154;
(statearr_44166[(7)] = inst_44118);

(statearr_44166[(9)] = inst_44117);

return statearr_44166;
})();
var statearr_44167_44198 = state_44154__$1;
(statearr_44167_44198[(2)] = null);

(statearr_44167_44198[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (11))){
var inst_44118 = (state_44154[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_44154,(10),Object,null,(9));
var inst_44127 = (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(inst_44118) : chs__$1.call(null,inst_44118));
var inst_44128 = (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(inst_44118) : done.call(null,inst_44118));
var inst_44129 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_44127,inst_44128);
var state_44154__$1 = state_44154;
var statearr_44168_44199 = state_44154__$1;
(statearr_44168_44199[(2)] = inst_44129);


cljs.core.async.impl.ioc_helpers.process_exception(state_44154__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (9))){
var inst_44118 = (state_44154[(7)]);
var inst_44131 = (state_44154[(2)]);
var inst_44132 = (inst_44118 + (1));
var inst_44118__$1 = inst_44132;
var state_44154__$1 = (function (){var statearr_44169 = state_44154;
(statearr_44169[(7)] = inst_44118__$1);

(statearr_44169[(10)] = inst_44131);

return statearr_44169;
})();
var statearr_44170_44200 = state_44154__$1;
(statearr_44170_44200[(2)] = null);

(statearr_44170_44200[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (5))){
var inst_44138 = (state_44154[(2)]);
var state_44154__$1 = (function (){var statearr_44171 = state_44154;
(statearr_44171[(11)] = inst_44138);

return statearr_44171;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_44154__$1,(12),dchan);
} else {
if((state_val_44155 === (14))){
var inst_44140 = (state_44154[(8)]);
var inst_44145 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_44140);
var state_44154__$1 = state_44154;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44154__$1,(16),out,inst_44145);
} else {
if((state_val_44155 === (16))){
var inst_44147 = (state_44154[(2)]);
var state_44154__$1 = (function (){var statearr_44172 = state_44154;
(statearr_44172[(12)] = inst_44147);

return statearr_44172;
})();
var statearr_44173_44201 = state_44154__$1;
(statearr_44173_44201[(2)] = null);

(statearr_44173_44201[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (10))){
var inst_44122 = (state_44154[(2)]);
var inst_44123 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_44154__$1 = (function (){var statearr_44174 = state_44154;
(statearr_44174[(13)] = inst_44122);

return statearr_44174;
})();
var statearr_44175_44202 = state_44154__$1;
(statearr_44175_44202[(2)] = inst_44123);


cljs.core.async.impl.ioc_helpers.process_exception(state_44154__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_44155 === (8))){
var inst_44136 = (state_44154[(2)]);
var state_44154__$1 = state_44154;
var statearr_44176_44203 = state_44154__$1;
(statearr_44176_44203[(2)] = inst_44136);

(statearr_44176_44203[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___44188,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__41984__auto__,c__42110__auto___44188,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_44180 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_44180[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_44180[(1)] = (1));

return statearr_44180;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_44154){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44154);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44181){if((e44181 instanceof Object)){
var ex__41988__auto__ = e44181;
var statearr_44182_44204 = state_44154;
(statearr_44182_44204[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44154);

return cljs.core.cst$kw$recur;
} else {
throw e44181;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44205 = state_44154;
state_44154 = G__44205;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_44154){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_44154);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___44188,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__42112__auto__ = (function (){var statearr_44183 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44183[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___44188);

return statearr_44183;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___44188,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args44207 = [];
var len__10461__auto___44265 = arguments.length;
var i__10462__auto___44266 = (0);
while(true){
if((i__10462__auto___44266 < len__10461__auto___44265)){
args44207.push((arguments[i__10462__auto___44266]));

var G__44267 = (i__10462__auto___44266 + (1));
i__10462__auto___44266 = G__44267;
continue;
} else {
}
break;
}

var G__44209 = args44207.length;
switch (G__44209) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44207.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__42110__auto___44269 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___44269,out){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___44269,out){
return (function (state_44241){
var state_val_44242 = (state_44241[(1)]);
if((state_val_44242 === (7))){
var inst_44220 = (state_44241[(7)]);
var inst_44221 = (state_44241[(8)]);
var inst_44220__$1 = (state_44241[(2)]);
var inst_44221__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_44220__$1,(0),null);
var inst_44222 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_44220__$1,(1),null);
var inst_44223 = (inst_44221__$1 == null);
var state_44241__$1 = (function (){var statearr_44243 = state_44241;
(statearr_44243[(7)] = inst_44220__$1);

(statearr_44243[(8)] = inst_44221__$1);

(statearr_44243[(9)] = inst_44222);

return statearr_44243;
})();
if(cljs.core.truth_(inst_44223)){
var statearr_44244_44270 = state_44241__$1;
(statearr_44244_44270[(1)] = (8));

} else {
var statearr_44245_44271 = state_44241__$1;
(statearr_44245_44271[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44242 === (1))){
var inst_44210 = cljs.core.vec(chs);
var inst_44211 = inst_44210;
var state_44241__$1 = (function (){var statearr_44246 = state_44241;
(statearr_44246[(10)] = inst_44211);

return statearr_44246;
})();
var statearr_44247_44272 = state_44241__$1;
(statearr_44247_44272[(2)] = null);

(statearr_44247_44272[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44242 === (4))){
var inst_44211 = (state_44241[(10)]);
var state_44241__$1 = state_44241;
return cljs.core.async.ioc_alts_BANG_(state_44241__$1,(7),inst_44211);
} else {
if((state_val_44242 === (6))){
var inst_44237 = (state_44241[(2)]);
var state_44241__$1 = state_44241;
var statearr_44248_44273 = state_44241__$1;
(statearr_44248_44273[(2)] = inst_44237);

(statearr_44248_44273[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44242 === (3))){
var inst_44239 = (state_44241[(2)]);
var state_44241__$1 = state_44241;
return cljs.core.async.impl.ioc_helpers.return_chan(state_44241__$1,inst_44239);
} else {
if((state_val_44242 === (2))){
var inst_44211 = (state_44241[(10)]);
var inst_44213 = cljs.core.count(inst_44211);
var inst_44214 = (inst_44213 > (0));
var state_44241__$1 = state_44241;
if(cljs.core.truth_(inst_44214)){
var statearr_44250_44274 = state_44241__$1;
(statearr_44250_44274[(1)] = (4));

} else {
var statearr_44251_44275 = state_44241__$1;
(statearr_44251_44275[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44242 === (11))){
var inst_44211 = (state_44241[(10)]);
var inst_44230 = (state_44241[(2)]);
var tmp44249 = inst_44211;
var inst_44211__$1 = tmp44249;
var state_44241__$1 = (function (){var statearr_44252 = state_44241;
(statearr_44252[(11)] = inst_44230);

(statearr_44252[(10)] = inst_44211__$1);

return statearr_44252;
})();
var statearr_44253_44276 = state_44241__$1;
(statearr_44253_44276[(2)] = null);

(statearr_44253_44276[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44242 === (9))){
var inst_44221 = (state_44241[(8)]);
var state_44241__$1 = state_44241;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44241__$1,(11),out,inst_44221);
} else {
if((state_val_44242 === (5))){
var inst_44235 = cljs.core.async.close_BANG_(out);
var state_44241__$1 = state_44241;
var statearr_44254_44277 = state_44241__$1;
(statearr_44254_44277[(2)] = inst_44235);

(statearr_44254_44277[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44242 === (10))){
var inst_44233 = (state_44241[(2)]);
var state_44241__$1 = state_44241;
var statearr_44255_44278 = state_44241__$1;
(statearr_44255_44278[(2)] = inst_44233);

(statearr_44255_44278[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44242 === (8))){
var inst_44220 = (state_44241[(7)]);
var inst_44221 = (state_44241[(8)]);
var inst_44222 = (state_44241[(9)]);
var inst_44211 = (state_44241[(10)]);
var inst_44225 = (function (){var cs = inst_44211;
var vec__44216 = inst_44220;
var v = inst_44221;
var c = inst_44222;
return ((function (cs,vec__44216,v,c,inst_44220,inst_44221,inst_44222,inst_44211,state_val_44242,c__42110__auto___44269,out){
return (function (p1__44206_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__44206_SHARP_);
});
;})(cs,vec__44216,v,c,inst_44220,inst_44221,inst_44222,inst_44211,state_val_44242,c__42110__auto___44269,out))
})();
var inst_44226 = cljs.core.filterv(inst_44225,inst_44211);
var inst_44211__$1 = inst_44226;
var state_44241__$1 = (function (){var statearr_44256 = state_44241;
(statearr_44256[(10)] = inst_44211__$1);

return statearr_44256;
})();
var statearr_44257_44279 = state_44241__$1;
(statearr_44257_44279[(2)] = null);

(statearr_44257_44279[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___44269,out))
;
return ((function (switch__41984__auto__,c__42110__auto___44269,out){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_44261 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_44261[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_44261[(1)] = (1));

return statearr_44261;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_44241){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44241);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44262){if((e44262 instanceof Object)){
var ex__41988__auto__ = e44262;
var statearr_44263_44280 = state_44241;
(statearr_44263_44280[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44241);

return cljs.core.cst$kw$recur;
} else {
throw e44262;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44281 = state_44241;
state_44241 = G__44281;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_44241){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_44241);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___44269,out))
})();
var state__42112__auto__ = (function (){var statearr_44264 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44264[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___44269);

return statearr_44264;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___44269,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args44282 = [];
var len__10461__auto___44331 = arguments.length;
var i__10462__auto___44332 = (0);
while(true){
if((i__10462__auto___44332 < len__10461__auto___44331)){
args44282.push((arguments[i__10462__auto___44332]));

var G__44333 = (i__10462__auto___44332 + (1));
i__10462__auto___44332 = G__44333;
continue;
} else {
}
break;
}

var G__44284 = args44282.length;
switch (G__44284) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44282.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__42110__auto___44335 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___44335,out){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___44335,out){
return (function (state_44308){
var state_val_44309 = (state_44308[(1)]);
if((state_val_44309 === (7))){
var inst_44290 = (state_44308[(7)]);
var inst_44290__$1 = (state_44308[(2)]);
var inst_44291 = (inst_44290__$1 == null);
var inst_44292 = cljs.core.not(inst_44291);
var state_44308__$1 = (function (){var statearr_44310 = state_44308;
(statearr_44310[(7)] = inst_44290__$1);

return statearr_44310;
})();
if(inst_44292){
var statearr_44311_44336 = state_44308__$1;
(statearr_44311_44336[(1)] = (8));

} else {
var statearr_44312_44337 = state_44308__$1;
(statearr_44312_44337[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44309 === (1))){
var inst_44285 = (0);
var state_44308__$1 = (function (){var statearr_44313 = state_44308;
(statearr_44313[(8)] = inst_44285);

return statearr_44313;
})();
var statearr_44314_44338 = state_44308__$1;
(statearr_44314_44338[(2)] = null);

(statearr_44314_44338[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44309 === (4))){
var state_44308__$1 = state_44308;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_44308__$1,(7),ch);
} else {
if((state_val_44309 === (6))){
var inst_44303 = (state_44308[(2)]);
var state_44308__$1 = state_44308;
var statearr_44315_44339 = state_44308__$1;
(statearr_44315_44339[(2)] = inst_44303);

(statearr_44315_44339[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44309 === (3))){
var inst_44305 = (state_44308[(2)]);
var inst_44306 = cljs.core.async.close_BANG_(out);
var state_44308__$1 = (function (){var statearr_44316 = state_44308;
(statearr_44316[(9)] = inst_44305);

return statearr_44316;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_44308__$1,inst_44306);
} else {
if((state_val_44309 === (2))){
var inst_44285 = (state_44308[(8)]);
var inst_44287 = (inst_44285 < n);
var state_44308__$1 = state_44308;
if(cljs.core.truth_(inst_44287)){
var statearr_44317_44340 = state_44308__$1;
(statearr_44317_44340[(1)] = (4));

} else {
var statearr_44318_44341 = state_44308__$1;
(statearr_44318_44341[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44309 === (11))){
var inst_44285 = (state_44308[(8)]);
var inst_44295 = (state_44308[(2)]);
var inst_44296 = (inst_44285 + (1));
var inst_44285__$1 = inst_44296;
var state_44308__$1 = (function (){var statearr_44319 = state_44308;
(statearr_44319[(8)] = inst_44285__$1);

(statearr_44319[(10)] = inst_44295);

return statearr_44319;
})();
var statearr_44320_44342 = state_44308__$1;
(statearr_44320_44342[(2)] = null);

(statearr_44320_44342[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44309 === (9))){
var state_44308__$1 = state_44308;
var statearr_44321_44343 = state_44308__$1;
(statearr_44321_44343[(2)] = null);

(statearr_44321_44343[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44309 === (5))){
var state_44308__$1 = state_44308;
var statearr_44322_44344 = state_44308__$1;
(statearr_44322_44344[(2)] = null);

(statearr_44322_44344[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44309 === (10))){
var inst_44300 = (state_44308[(2)]);
var state_44308__$1 = state_44308;
var statearr_44323_44345 = state_44308__$1;
(statearr_44323_44345[(2)] = inst_44300);

(statearr_44323_44345[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44309 === (8))){
var inst_44290 = (state_44308[(7)]);
var state_44308__$1 = state_44308;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44308__$1,(11),out,inst_44290);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___44335,out))
;
return ((function (switch__41984__auto__,c__42110__auto___44335,out){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_44327 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_44327[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_44327[(1)] = (1));

return statearr_44327;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_44308){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44308);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44328){if((e44328 instanceof Object)){
var ex__41988__auto__ = e44328;
var statearr_44329_44346 = state_44308;
(statearr_44329_44346[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44308);

return cljs.core.cst$kw$recur;
} else {
throw e44328;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44347 = state_44308;
state_44308 = G__44347;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_44308){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_44308);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___44335,out))
})();
var state__42112__auto__ = (function (){var statearr_44330 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44330[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___44335);

return statearr_44330;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___44335,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async44357 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async44357 = (function (map_LT_,f,ch,meta44358){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta44358 = meta44358;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_44359,meta44358__$1){
var self__ = this;
var _44359__$1 = this;
return (new cljs.core.async.t_cljs$core$async44357(self__.map_LT_,self__.f,self__.ch,meta44358__$1));
});

cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_44359){
var self__ = this;
var _44359__$1 = this;
return self__.meta44358;
});

cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async44360 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async44360 = (function (map_LT_,f,ch,meta44358,_,fn1,meta44361){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta44358 = meta44358;
this._ = _;
this.fn1 = fn1;
this.meta44361 = meta44361;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async44360.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_44362,meta44361__$1){
var self__ = this;
var _44362__$1 = this;
return (new cljs.core.async.t_cljs$core$async44360(self__.map_LT_,self__.f,self__.ch,self__.meta44358,self__._,self__.fn1,meta44361__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async44360.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_44362){
var self__ = this;
var _44362__$1 = this;
return self__.meta44361;
});})(___$1))
;

cljs.core.async.t_cljs$core$async44360.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t_cljs$core$async44360.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async44360.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async44360.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__44348_SHARP_){
var G__44363 = (((p1__44348_SHARP_ == null))?null:(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(p1__44348_SHARP_) : self__.f.call(null,p1__44348_SHARP_)));
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__44363) : f1.call(null,G__44363));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async44360.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_LT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta44358,cljs.core.with_meta(cljs.core.cst$sym$_,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$tag,cljs.core.cst$sym$cljs$core$async_SLASH_t_cljs$core$async44357], null)),cljs.core.cst$sym$fn1,cljs.core.cst$sym$meta44361], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async44360.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async44360.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async44360";

cljs.core.async.t_cljs$core$async44360.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async44360");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async44360 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async44360(map_LT___$1,f__$1,ch__$1,meta44358__$1,___$2,fn1__$1,meta44361){
return (new cljs.core.async.t_cljs$core$async44360(map_LT___$1,f__$1,ch__$1,meta44358__$1,___$2,fn1__$1,meta44361));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async44360(self__.map_LT_,self__.f,self__.ch,self__.meta44358,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__9266__auto__ = ret;
if(cljs.core.truth_(and__9266__auto__)){
return !(((cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret)) == null));
} else {
return and__9266__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__44364 = (cljs.core.deref.cljs$core$IFn$_invoke$arity$1 ? cljs.core.deref.cljs$core$IFn$_invoke$arity$1(ret) : cljs.core.deref.call(null,ret));
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__44364) : self__.f.call(null,G__44364));
})());
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async44357.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async44357.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_LT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta44358], null);
});

cljs.core.async.t_cljs$core$async44357.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async44357.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async44357";

cljs.core.async.t_cljs$core$async44357.cljs$lang$ctorPrWriter = (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async44357");
});

cljs.core.async.__GT_t_cljs$core$async44357 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async44357(map_LT___$1,f__$1,ch__$1,meta44358){
return (new cljs.core.async.t_cljs$core$async44357(map_LT___$1,f__$1,ch__$1,meta44358));
});

}

return (new cljs.core.async.t_cljs$core$async44357(cljs$core$async$map_LT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async44368 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async44368 = (function (map_GT_,f,ch,meta44369){
this.map_GT_ = map_GT_;
this.f = f;
this.ch = ch;
this.meta44369 = meta44369;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async44368.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_44370,meta44369__$1){
var self__ = this;
var _44370__$1 = this;
return (new cljs.core.async.t_cljs$core$async44368(self__.map_GT_,self__.f,self__.ch,meta44369__$1));
});

cljs.core.async.t_cljs$core$async44368.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_44370){
var self__ = this;
var _44370__$1 = this;
return self__.meta44369;
});

cljs.core.async.t_cljs$core$async44368.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async44368.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async44368.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async44368.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async44368.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async44368.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(val) : self__.f.call(null,val)),fn1);
});

cljs.core.async.t_cljs$core$async44368.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$map_GT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta44369], null);
});

cljs.core.async.t_cljs$core$async44368.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async44368.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async44368";

cljs.core.async.t_cljs$core$async44368.cljs$lang$ctorPrWriter = (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async44368");
});

cljs.core.async.__GT_t_cljs$core$async44368 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async44368(map_GT___$1,f__$1,ch__$1,meta44369){
return (new cljs.core.async.t_cljs$core$async44368(map_GT___$1,f__$1,ch__$1,meta44369));
});

}

return (new cljs.core.async.t_cljs$core$async44368(cljs$core$async$map_GT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async44374 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async44374 = (function (filter_GT_,p,ch,meta44375){
this.filter_GT_ = filter_GT_;
this.p = p;
this.ch = ch;
this.meta44375 = meta44375;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_44376,meta44375__$1){
var self__ = this;
var _44376__$1 = this;
return (new cljs.core.async.t_cljs$core$async44374(self__.filter_GT_,self__.p,self__.ch,meta44375__$1));
});

cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_44376){
var self__ = this;
var _44376__$1 = this;
return self__.meta44375;
});

cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t_cljs$core$async44374.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(val) : self__.p.call(null,val)))){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
});

cljs.core.async.t_cljs$core$async44374.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(cljs.core.cst$sym$filter_GT_,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$arglists,cljs.core.list(cljs.core.cst$sym$quote,cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$p,cljs.core.cst$sym$ch], null))),cljs.core.cst$kw$doc,"Deprecated - this function will be removed. Use transducer instead"], null)),cljs.core.cst$sym$p,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta44375], null);
});

cljs.core.async.t_cljs$core$async44374.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async44374.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async44374";

cljs.core.async.t_cljs$core$async44374.cljs$lang$ctorPrWriter = (function (this__9930__auto__,writer__9931__auto__,opt__9932__auto__){
return cljs.core._write(writer__9931__auto__,"cljs.core.async/t_cljs$core$async44374");
});

cljs.core.async.__GT_t_cljs$core$async44374 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async44374(filter_GT___$1,p__$1,ch__$1,meta44375){
return (new cljs.core.async.t_cljs$core$async44374(filter_GT___$1,p__$1,ch__$1,meta44375));
});

}

return (new cljs.core.async.t_cljs$core$async44374(cljs$core$async$filter_GT_,p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args44377 = [];
var len__10461__auto___44421 = arguments.length;
var i__10462__auto___44422 = (0);
while(true){
if((i__10462__auto___44422 < len__10461__auto___44421)){
args44377.push((arguments[i__10462__auto___44422]));

var G__44423 = (i__10462__auto___44422 + (1));
i__10462__auto___44422 = G__44423;
continue;
} else {
}
break;
}

var G__44379 = args44377.length;
switch (G__44379) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44377.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__42110__auto___44425 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___44425,out){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___44425,out){
return (function (state_44400){
var state_val_44401 = (state_44400[(1)]);
if((state_val_44401 === (7))){
var inst_44396 = (state_44400[(2)]);
var state_44400__$1 = state_44400;
var statearr_44402_44426 = state_44400__$1;
(statearr_44402_44426[(2)] = inst_44396);

(statearr_44402_44426[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44401 === (1))){
var state_44400__$1 = state_44400;
var statearr_44403_44427 = state_44400__$1;
(statearr_44403_44427[(2)] = null);

(statearr_44403_44427[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44401 === (4))){
var inst_44382 = (state_44400[(7)]);
var inst_44382__$1 = (state_44400[(2)]);
var inst_44383 = (inst_44382__$1 == null);
var state_44400__$1 = (function (){var statearr_44404 = state_44400;
(statearr_44404[(7)] = inst_44382__$1);

return statearr_44404;
})();
if(cljs.core.truth_(inst_44383)){
var statearr_44405_44428 = state_44400__$1;
(statearr_44405_44428[(1)] = (5));

} else {
var statearr_44406_44429 = state_44400__$1;
(statearr_44406_44429[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44401 === (6))){
var inst_44382 = (state_44400[(7)]);
var inst_44387 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_44382) : p.call(null,inst_44382));
var state_44400__$1 = state_44400;
if(cljs.core.truth_(inst_44387)){
var statearr_44407_44430 = state_44400__$1;
(statearr_44407_44430[(1)] = (8));

} else {
var statearr_44408_44431 = state_44400__$1;
(statearr_44408_44431[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44401 === (3))){
var inst_44398 = (state_44400[(2)]);
var state_44400__$1 = state_44400;
return cljs.core.async.impl.ioc_helpers.return_chan(state_44400__$1,inst_44398);
} else {
if((state_val_44401 === (2))){
var state_44400__$1 = state_44400;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_44400__$1,(4),ch);
} else {
if((state_val_44401 === (11))){
var inst_44390 = (state_44400[(2)]);
var state_44400__$1 = state_44400;
var statearr_44409_44432 = state_44400__$1;
(statearr_44409_44432[(2)] = inst_44390);

(statearr_44409_44432[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44401 === (9))){
var state_44400__$1 = state_44400;
var statearr_44410_44433 = state_44400__$1;
(statearr_44410_44433[(2)] = null);

(statearr_44410_44433[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44401 === (5))){
var inst_44385 = cljs.core.async.close_BANG_(out);
var state_44400__$1 = state_44400;
var statearr_44411_44434 = state_44400__$1;
(statearr_44411_44434[(2)] = inst_44385);

(statearr_44411_44434[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44401 === (10))){
var inst_44393 = (state_44400[(2)]);
var state_44400__$1 = (function (){var statearr_44412 = state_44400;
(statearr_44412[(8)] = inst_44393);

return statearr_44412;
})();
var statearr_44413_44435 = state_44400__$1;
(statearr_44413_44435[(2)] = null);

(statearr_44413_44435[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44401 === (8))){
var inst_44382 = (state_44400[(7)]);
var state_44400__$1 = state_44400;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44400__$1,(11),out,inst_44382);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___44425,out))
;
return ((function (switch__41984__auto__,c__42110__auto___44425,out){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_44417 = [null,null,null,null,null,null,null,null,null];
(statearr_44417[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_44417[(1)] = (1));

return statearr_44417;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_44400){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44400);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44418){if((e44418 instanceof Object)){
var ex__41988__auto__ = e44418;
var statearr_44419_44436 = state_44400;
(statearr_44419_44436[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44400);

return cljs.core.cst$kw$recur;
} else {
throw e44418;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44437 = state_44400;
state_44400 = G__44437;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_44400){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_44400);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___44425,out))
})();
var state__42112__auto__ = (function (){var statearr_44420 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44420[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___44425);

return statearr_44420;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___44425,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args44438 = [];
var len__10461__auto___44441 = arguments.length;
var i__10462__auto___44442 = (0);
while(true){
if((i__10462__auto___44442 < len__10461__auto___44441)){
args44438.push((arguments[i__10462__auto___44442]));

var G__44443 = (i__10462__auto___44442 + (1));
i__10462__auto___44442 = G__44443;
continue;
} else {
}
break;
}

var G__44440 = args44438.length;
switch (G__44440) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44438.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__42110__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto__){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto__){
return (function (state_44610){
var state_val_44611 = (state_44610[(1)]);
if((state_val_44611 === (7))){
var inst_44606 = (state_44610[(2)]);
var state_44610__$1 = state_44610;
var statearr_44612_44653 = state_44610__$1;
(statearr_44612_44653[(2)] = inst_44606);

(statearr_44612_44653[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (20))){
var inst_44576 = (state_44610[(7)]);
var inst_44587 = (state_44610[(2)]);
var inst_44588 = cljs.core.next(inst_44576);
var inst_44562 = inst_44588;
var inst_44563 = null;
var inst_44564 = (0);
var inst_44565 = (0);
var state_44610__$1 = (function (){var statearr_44613 = state_44610;
(statearr_44613[(8)] = inst_44563);

(statearr_44613[(9)] = inst_44587);

(statearr_44613[(10)] = inst_44564);

(statearr_44613[(11)] = inst_44562);

(statearr_44613[(12)] = inst_44565);

return statearr_44613;
})();
var statearr_44614_44654 = state_44610__$1;
(statearr_44614_44654[(2)] = null);

(statearr_44614_44654[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (1))){
var state_44610__$1 = state_44610;
var statearr_44615_44655 = state_44610__$1;
(statearr_44615_44655[(2)] = null);

(statearr_44615_44655[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (4))){
var inst_44551 = (state_44610[(13)]);
var inst_44551__$1 = (state_44610[(2)]);
var inst_44552 = (inst_44551__$1 == null);
var state_44610__$1 = (function (){var statearr_44616 = state_44610;
(statearr_44616[(13)] = inst_44551__$1);

return statearr_44616;
})();
if(cljs.core.truth_(inst_44552)){
var statearr_44617_44656 = state_44610__$1;
(statearr_44617_44656[(1)] = (5));

} else {
var statearr_44618_44657 = state_44610__$1;
(statearr_44618_44657[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (15))){
var state_44610__$1 = state_44610;
var statearr_44622_44658 = state_44610__$1;
(statearr_44622_44658[(2)] = null);

(statearr_44622_44658[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (21))){
var state_44610__$1 = state_44610;
var statearr_44623_44659 = state_44610__$1;
(statearr_44623_44659[(2)] = null);

(statearr_44623_44659[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (13))){
var inst_44563 = (state_44610[(8)]);
var inst_44564 = (state_44610[(10)]);
var inst_44562 = (state_44610[(11)]);
var inst_44565 = (state_44610[(12)]);
var inst_44572 = (state_44610[(2)]);
var inst_44573 = (inst_44565 + (1));
var tmp44619 = inst_44563;
var tmp44620 = inst_44564;
var tmp44621 = inst_44562;
var inst_44562__$1 = tmp44621;
var inst_44563__$1 = tmp44619;
var inst_44564__$1 = tmp44620;
var inst_44565__$1 = inst_44573;
var state_44610__$1 = (function (){var statearr_44624 = state_44610;
(statearr_44624[(8)] = inst_44563__$1);

(statearr_44624[(10)] = inst_44564__$1);

(statearr_44624[(11)] = inst_44562__$1);

(statearr_44624[(12)] = inst_44565__$1);

(statearr_44624[(14)] = inst_44572);

return statearr_44624;
})();
var statearr_44625_44660 = state_44610__$1;
(statearr_44625_44660[(2)] = null);

(statearr_44625_44660[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (22))){
var state_44610__$1 = state_44610;
var statearr_44626_44661 = state_44610__$1;
(statearr_44626_44661[(2)] = null);

(statearr_44626_44661[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (6))){
var inst_44551 = (state_44610[(13)]);
var inst_44560 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_44551) : f.call(null,inst_44551));
var inst_44561 = cljs.core.seq(inst_44560);
var inst_44562 = inst_44561;
var inst_44563 = null;
var inst_44564 = (0);
var inst_44565 = (0);
var state_44610__$1 = (function (){var statearr_44627 = state_44610;
(statearr_44627[(8)] = inst_44563);

(statearr_44627[(10)] = inst_44564);

(statearr_44627[(11)] = inst_44562);

(statearr_44627[(12)] = inst_44565);

return statearr_44627;
})();
var statearr_44628_44662 = state_44610__$1;
(statearr_44628_44662[(2)] = null);

(statearr_44628_44662[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (17))){
var inst_44576 = (state_44610[(7)]);
var inst_44580 = cljs.core.chunk_first(inst_44576);
var inst_44581 = cljs.core.chunk_rest(inst_44576);
var inst_44582 = cljs.core.count(inst_44580);
var inst_44562 = inst_44581;
var inst_44563 = inst_44580;
var inst_44564 = inst_44582;
var inst_44565 = (0);
var state_44610__$1 = (function (){var statearr_44629 = state_44610;
(statearr_44629[(8)] = inst_44563);

(statearr_44629[(10)] = inst_44564);

(statearr_44629[(11)] = inst_44562);

(statearr_44629[(12)] = inst_44565);

return statearr_44629;
})();
var statearr_44630_44663 = state_44610__$1;
(statearr_44630_44663[(2)] = null);

(statearr_44630_44663[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (3))){
var inst_44608 = (state_44610[(2)]);
var state_44610__$1 = state_44610;
return cljs.core.async.impl.ioc_helpers.return_chan(state_44610__$1,inst_44608);
} else {
if((state_val_44611 === (12))){
var inst_44596 = (state_44610[(2)]);
var state_44610__$1 = state_44610;
var statearr_44631_44664 = state_44610__$1;
(statearr_44631_44664[(2)] = inst_44596);

(statearr_44631_44664[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (2))){
var state_44610__$1 = state_44610;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_44610__$1,(4),in$);
} else {
if((state_val_44611 === (23))){
var inst_44604 = (state_44610[(2)]);
var state_44610__$1 = state_44610;
var statearr_44632_44665 = state_44610__$1;
(statearr_44632_44665[(2)] = inst_44604);

(statearr_44632_44665[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (19))){
var inst_44591 = (state_44610[(2)]);
var state_44610__$1 = state_44610;
var statearr_44633_44666 = state_44610__$1;
(statearr_44633_44666[(2)] = inst_44591);

(statearr_44633_44666[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (11))){
var inst_44576 = (state_44610[(7)]);
var inst_44562 = (state_44610[(11)]);
var inst_44576__$1 = cljs.core.seq(inst_44562);
var state_44610__$1 = (function (){var statearr_44634 = state_44610;
(statearr_44634[(7)] = inst_44576__$1);

return statearr_44634;
})();
if(inst_44576__$1){
var statearr_44635_44667 = state_44610__$1;
(statearr_44635_44667[(1)] = (14));

} else {
var statearr_44636_44668 = state_44610__$1;
(statearr_44636_44668[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (9))){
var inst_44598 = (state_44610[(2)]);
var inst_44599 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_44610__$1 = (function (){var statearr_44637 = state_44610;
(statearr_44637[(15)] = inst_44598);

return statearr_44637;
})();
if(cljs.core.truth_(inst_44599)){
var statearr_44638_44669 = state_44610__$1;
(statearr_44638_44669[(1)] = (21));

} else {
var statearr_44639_44670 = state_44610__$1;
(statearr_44639_44670[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (5))){
var inst_44554 = cljs.core.async.close_BANG_(out);
var state_44610__$1 = state_44610;
var statearr_44640_44671 = state_44610__$1;
(statearr_44640_44671[(2)] = inst_44554);

(statearr_44640_44671[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (14))){
var inst_44576 = (state_44610[(7)]);
var inst_44578 = cljs.core.chunked_seq_QMARK_(inst_44576);
var state_44610__$1 = state_44610;
if(inst_44578){
var statearr_44641_44672 = state_44610__$1;
(statearr_44641_44672[(1)] = (17));

} else {
var statearr_44642_44673 = state_44610__$1;
(statearr_44642_44673[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (16))){
var inst_44594 = (state_44610[(2)]);
var state_44610__$1 = state_44610;
var statearr_44643_44674 = state_44610__$1;
(statearr_44643_44674[(2)] = inst_44594);

(statearr_44643_44674[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44611 === (10))){
var inst_44563 = (state_44610[(8)]);
var inst_44565 = (state_44610[(12)]);
var inst_44570 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_44563,inst_44565);
var state_44610__$1 = state_44610;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44610__$1,(13),out,inst_44570);
} else {
if((state_val_44611 === (18))){
var inst_44576 = (state_44610[(7)]);
var inst_44585 = cljs.core.first(inst_44576);
var state_44610__$1 = state_44610;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44610__$1,(20),out,inst_44585);
} else {
if((state_val_44611 === (8))){
var inst_44564 = (state_44610[(10)]);
var inst_44565 = (state_44610[(12)]);
var inst_44567 = (inst_44565 < inst_44564);
var inst_44568 = inst_44567;
var state_44610__$1 = state_44610;
if(cljs.core.truth_(inst_44568)){
var statearr_44644_44675 = state_44610__$1;
(statearr_44644_44675[(1)] = (10));

} else {
var statearr_44645_44676 = state_44610__$1;
(statearr_44645_44676[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto__))
;
return ((function (switch__41984__auto__,c__42110__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__41985__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__41985__auto____0 = (function (){
var statearr_44649 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_44649[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__41985__auto__);

(statearr_44649[(1)] = (1));

return statearr_44649;
});
var cljs$core$async$mapcat_STAR__$_state_machine__41985__auto____1 = (function (state_44610){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44610);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44650){if((e44650 instanceof Object)){
var ex__41988__auto__ = e44650;
var statearr_44651_44677 = state_44610;
(statearr_44651_44677[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44610);

return cljs.core.cst$kw$recur;
} else {
throw e44650;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44678 = state_44610;
state_44610 = G__44678;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__41985__auto__ = function(state_44610){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__41985__auto____1.call(this,state_44610);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__41985__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__41985__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto__))
})();
var state__42112__auto__ = (function (){var statearr_44652 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44652[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto__);

return statearr_44652;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto__))
);

return c__42110__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args44679 = [];
var len__10461__auto___44682 = arguments.length;
var i__10462__auto___44683 = (0);
while(true){
if((i__10462__auto___44683 < len__10461__auto___44682)){
args44679.push((arguments[i__10462__auto___44683]));

var G__44684 = (i__10462__auto___44683 + (1));
i__10462__auto___44683 = G__44684;
continue;
} else {
}
break;
}

var G__44681 = args44679.length;
switch (G__44681) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44679.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args44686 = [];
var len__10461__auto___44689 = arguments.length;
var i__10462__auto___44690 = (0);
while(true){
if((i__10462__auto___44690 < len__10461__auto___44689)){
args44686.push((arguments[i__10462__auto___44690]));

var G__44691 = (i__10462__auto___44690 + (1));
i__10462__auto___44690 = G__44691;
continue;
} else {
}
break;
}

var G__44688 = args44686.length;
switch (G__44688) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44686.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args44693 = [];
var len__10461__auto___44744 = arguments.length;
var i__10462__auto___44745 = (0);
while(true){
if((i__10462__auto___44745 < len__10461__auto___44744)){
args44693.push((arguments[i__10462__auto___44745]));

var G__44746 = (i__10462__auto___44745 + (1));
i__10462__auto___44745 = G__44746;
continue;
} else {
}
break;
}

var G__44695 = args44693.length;
switch (G__44695) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44693.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__42110__auto___44748 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___44748,out){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___44748,out){
return (function (state_44719){
var state_val_44720 = (state_44719[(1)]);
if((state_val_44720 === (7))){
var inst_44714 = (state_44719[(2)]);
var state_44719__$1 = state_44719;
var statearr_44721_44749 = state_44719__$1;
(statearr_44721_44749[(2)] = inst_44714);

(statearr_44721_44749[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44720 === (1))){
var inst_44696 = null;
var state_44719__$1 = (function (){var statearr_44722 = state_44719;
(statearr_44722[(7)] = inst_44696);

return statearr_44722;
})();
var statearr_44723_44750 = state_44719__$1;
(statearr_44723_44750[(2)] = null);

(statearr_44723_44750[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44720 === (4))){
var inst_44699 = (state_44719[(8)]);
var inst_44699__$1 = (state_44719[(2)]);
var inst_44700 = (inst_44699__$1 == null);
var inst_44701 = cljs.core.not(inst_44700);
var state_44719__$1 = (function (){var statearr_44724 = state_44719;
(statearr_44724[(8)] = inst_44699__$1);

return statearr_44724;
})();
if(inst_44701){
var statearr_44725_44751 = state_44719__$1;
(statearr_44725_44751[(1)] = (5));

} else {
var statearr_44726_44752 = state_44719__$1;
(statearr_44726_44752[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44720 === (6))){
var state_44719__$1 = state_44719;
var statearr_44727_44753 = state_44719__$1;
(statearr_44727_44753[(2)] = null);

(statearr_44727_44753[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44720 === (3))){
var inst_44716 = (state_44719[(2)]);
var inst_44717 = cljs.core.async.close_BANG_(out);
var state_44719__$1 = (function (){var statearr_44728 = state_44719;
(statearr_44728[(9)] = inst_44716);

return statearr_44728;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_44719__$1,inst_44717);
} else {
if((state_val_44720 === (2))){
var state_44719__$1 = state_44719;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_44719__$1,(4),ch);
} else {
if((state_val_44720 === (11))){
var inst_44699 = (state_44719[(8)]);
var inst_44708 = (state_44719[(2)]);
var inst_44696 = inst_44699;
var state_44719__$1 = (function (){var statearr_44729 = state_44719;
(statearr_44729[(10)] = inst_44708);

(statearr_44729[(7)] = inst_44696);

return statearr_44729;
})();
var statearr_44730_44754 = state_44719__$1;
(statearr_44730_44754[(2)] = null);

(statearr_44730_44754[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44720 === (9))){
var inst_44699 = (state_44719[(8)]);
var state_44719__$1 = state_44719;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44719__$1,(11),out,inst_44699);
} else {
if((state_val_44720 === (5))){
var inst_44699 = (state_44719[(8)]);
var inst_44696 = (state_44719[(7)]);
var inst_44703 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_44699,inst_44696);
var state_44719__$1 = state_44719;
if(inst_44703){
var statearr_44732_44755 = state_44719__$1;
(statearr_44732_44755[(1)] = (8));

} else {
var statearr_44733_44756 = state_44719__$1;
(statearr_44733_44756[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44720 === (10))){
var inst_44711 = (state_44719[(2)]);
var state_44719__$1 = state_44719;
var statearr_44734_44757 = state_44719__$1;
(statearr_44734_44757[(2)] = inst_44711);

(statearr_44734_44757[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44720 === (8))){
var inst_44696 = (state_44719[(7)]);
var tmp44731 = inst_44696;
var inst_44696__$1 = tmp44731;
var state_44719__$1 = (function (){var statearr_44735 = state_44719;
(statearr_44735[(7)] = inst_44696__$1);

return statearr_44735;
})();
var statearr_44736_44758 = state_44719__$1;
(statearr_44736_44758[(2)] = null);

(statearr_44736_44758[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___44748,out))
;
return ((function (switch__41984__auto__,c__42110__auto___44748,out){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_44740 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_44740[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_44740[(1)] = (1));

return statearr_44740;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_44719){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44719);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44741){if((e44741 instanceof Object)){
var ex__41988__auto__ = e44741;
var statearr_44742_44759 = state_44719;
(statearr_44742_44759[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44719);

return cljs.core.cst$kw$recur;
} else {
throw e44741;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44760 = state_44719;
state_44719 = G__44760;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_44719){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_44719);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___44748,out))
})();
var state__42112__auto__ = (function (){var statearr_44743 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44743[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___44748);

return statearr_44743;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___44748,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args44761 = [];
var len__10461__auto___44831 = arguments.length;
var i__10462__auto___44832 = (0);
while(true){
if((i__10462__auto___44832 < len__10461__auto___44831)){
args44761.push((arguments[i__10462__auto___44832]));

var G__44833 = (i__10462__auto___44832 + (1));
i__10462__auto___44832 = G__44833;
continue;
} else {
}
break;
}

var G__44763 = args44761.length;
switch (G__44763) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44761.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__42110__auto___44835 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___44835,out){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___44835,out){
return (function (state_44801){
var state_val_44802 = (state_44801[(1)]);
if((state_val_44802 === (7))){
var inst_44797 = (state_44801[(2)]);
var state_44801__$1 = state_44801;
var statearr_44803_44836 = state_44801__$1;
(statearr_44803_44836[(2)] = inst_44797);

(statearr_44803_44836[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (1))){
var inst_44764 = (new Array(n));
var inst_44765 = inst_44764;
var inst_44766 = (0);
var state_44801__$1 = (function (){var statearr_44804 = state_44801;
(statearr_44804[(7)] = inst_44765);

(statearr_44804[(8)] = inst_44766);

return statearr_44804;
})();
var statearr_44805_44837 = state_44801__$1;
(statearr_44805_44837[(2)] = null);

(statearr_44805_44837[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (4))){
var inst_44769 = (state_44801[(9)]);
var inst_44769__$1 = (state_44801[(2)]);
var inst_44770 = (inst_44769__$1 == null);
var inst_44771 = cljs.core.not(inst_44770);
var state_44801__$1 = (function (){var statearr_44806 = state_44801;
(statearr_44806[(9)] = inst_44769__$1);

return statearr_44806;
})();
if(inst_44771){
var statearr_44807_44838 = state_44801__$1;
(statearr_44807_44838[(1)] = (5));

} else {
var statearr_44808_44839 = state_44801__$1;
(statearr_44808_44839[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (15))){
var inst_44791 = (state_44801[(2)]);
var state_44801__$1 = state_44801;
var statearr_44809_44840 = state_44801__$1;
(statearr_44809_44840[(2)] = inst_44791);

(statearr_44809_44840[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (13))){
var state_44801__$1 = state_44801;
var statearr_44810_44841 = state_44801__$1;
(statearr_44810_44841[(2)] = null);

(statearr_44810_44841[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (6))){
var inst_44766 = (state_44801[(8)]);
var inst_44787 = (inst_44766 > (0));
var state_44801__$1 = state_44801;
if(cljs.core.truth_(inst_44787)){
var statearr_44811_44842 = state_44801__$1;
(statearr_44811_44842[(1)] = (12));

} else {
var statearr_44812_44843 = state_44801__$1;
(statearr_44812_44843[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (3))){
var inst_44799 = (state_44801[(2)]);
var state_44801__$1 = state_44801;
return cljs.core.async.impl.ioc_helpers.return_chan(state_44801__$1,inst_44799);
} else {
if((state_val_44802 === (12))){
var inst_44765 = (state_44801[(7)]);
var inst_44789 = cljs.core.vec(inst_44765);
var state_44801__$1 = state_44801;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44801__$1,(15),out,inst_44789);
} else {
if((state_val_44802 === (2))){
var state_44801__$1 = state_44801;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_44801__$1,(4),ch);
} else {
if((state_val_44802 === (11))){
var inst_44781 = (state_44801[(2)]);
var inst_44782 = (new Array(n));
var inst_44765 = inst_44782;
var inst_44766 = (0);
var state_44801__$1 = (function (){var statearr_44813 = state_44801;
(statearr_44813[(10)] = inst_44781);

(statearr_44813[(7)] = inst_44765);

(statearr_44813[(8)] = inst_44766);

return statearr_44813;
})();
var statearr_44814_44844 = state_44801__$1;
(statearr_44814_44844[(2)] = null);

(statearr_44814_44844[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (9))){
var inst_44765 = (state_44801[(7)]);
var inst_44779 = cljs.core.vec(inst_44765);
var state_44801__$1 = state_44801;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44801__$1,(11),out,inst_44779);
} else {
if((state_val_44802 === (5))){
var inst_44774 = (state_44801[(11)]);
var inst_44769 = (state_44801[(9)]);
var inst_44765 = (state_44801[(7)]);
var inst_44766 = (state_44801[(8)]);
var inst_44773 = (inst_44765[inst_44766] = inst_44769);
var inst_44774__$1 = (inst_44766 + (1));
var inst_44775 = (inst_44774__$1 < n);
var state_44801__$1 = (function (){var statearr_44815 = state_44801;
(statearr_44815[(11)] = inst_44774__$1);

(statearr_44815[(12)] = inst_44773);

return statearr_44815;
})();
if(cljs.core.truth_(inst_44775)){
var statearr_44816_44845 = state_44801__$1;
(statearr_44816_44845[(1)] = (8));

} else {
var statearr_44817_44846 = state_44801__$1;
(statearr_44817_44846[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (14))){
var inst_44794 = (state_44801[(2)]);
var inst_44795 = cljs.core.async.close_BANG_(out);
var state_44801__$1 = (function (){var statearr_44819 = state_44801;
(statearr_44819[(13)] = inst_44794);

return statearr_44819;
})();
var statearr_44820_44847 = state_44801__$1;
(statearr_44820_44847[(2)] = inst_44795);

(statearr_44820_44847[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (10))){
var inst_44785 = (state_44801[(2)]);
var state_44801__$1 = state_44801;
var statearr_44821_44848 = state_44801__$1;
(statearr_44821_44848[(2)] = inst_44785);

(statearr_44821_44848[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44802 === (8))){
var inst_44774 = (state_44801[(11)]);
var inst_44765 = (state_44801[(7)]);
var tmp44818 = inst_44765;
var inst_44765__$1 = tmp44818;
var inst_44766 = inst_44774;
var state_44801__$1 = (function (){var statearr_44822 = state_44801;
(statearr_44822[(7)] = inst_44765__$1);

(statearr_44822[(8)] = inst_44766);

return statearr_44822;
})();
var statearr_44823_44849 = state_44801__$1;
(statearr_44823_44849[(2)] = null);

(statearr_44823_44849[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___44835,out))
;
return ((function (switch__41984__auto__,c__42110__auto___44835,out){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_44827 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_44827[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_44827[(1)] = (1));

return statearr_44827;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_44801){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44801);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44828){if((e44828 instanceof Object)){
var ex__41988__auto__ = e44828;
var statearr_44829_44850 = state_44801;
(statearr_44829_44850[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44801);

return cljs.core.cst$kw$recur;
} else {
throw e44828;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44851 = state_44801;
state_44801 = G__44851;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_44801){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_44801);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___44835,out))
})();
var state__42112__auto__ = (function (){var statearr_44830 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44830[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___44835);

return statearr_44830;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___44835,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args44852 = [];
var len__10461__auto___44926 = arguments.length;
var i__10462__auto___44927 = (0);
while(true){
if((i__10462__auto___44927 < len__10461__auto___44926)){
args44852.push((arguments[i__10462__auto___44927]));

var G__44928 = (i__10462__auto___44927 + (1));
i__10462__auto___44927 = G__44928;
continue;
} else {
}
break;
}

var G__44854 = args44852.length;
switch (G__44854) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args44852.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__42110__auto___44930 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__42110__auto___44930,out){
return (function (){
var f__42111__auto__ = (function (){var switch__41984__auto__ = ((function (c__42110__auto___44930,out){
return (function (state_44896){
var state_val_44897 = (state_44896[(1)]);
if((state_val_44897 === (7))){
var inst_44892 = (state_44896[(2)]);
var state_44896__$1 = state_44896;
var statearr_44898_44931 = state_44896__$1;
(statearr_44898_44931[(2)] = inst_44892);

(statearr_44898_44931[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (1))){
var inst_44855 = [];
var inst_44856 = inst_44855;
var inst_44857 = cljs.core.cst$kw$cljs$core$async_SLASH_nothing;
var state_44896__$1 = (function (){var statearr_44899 = state_44896;
(statearr_44899[(7)] = inst_44856);

(statearr_44899[(8)] = inst_44857);

return statearr_44899;
})();
var statearr_44900_44932 = state_44896__$1;
(statearr_44900_44932[(2)] = null);

(statearr_44900_44932[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (4))){
var inst_44860 = (state_44896[(9)]);
var inst_44860__$1 = (state_44896[(2)]);
var inst_44861 = (inst_44860__$1 == null);
var inst_44862 = cljs.core.not(inst_44861);
var state_44896__$1 = (function (){var statearr_44901 = state_44896;
(statearr_44901[(9)] = inst_44860__$1);

return statearr_44901;
})();
if(inst_44862){
var statearr_44902_44933 = state_44896__$1;
(statearr_44902_44933[(1)] = (5));

} else {
var statearr_44903_44934 = state_44896__$1;
(statearr_44903_44934[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (15))){
var inst_44886 = (state_44896[(2)]);
var state_44896__$1 = state_44896;
var statearr_44904_44935 = state_44896__$1;
(statearr_44904_44935[(2)] = inst_44886);

(statearr_44904_44935[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (13))){
var state_44896__$1 = state_44896;
var statearr_44905_44936 = state_44896__$1;
(statearr_44905_44936[(2)] = null);

(statearr_44905_44936[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (6))){
var inst_44856 = (state_44896[(7)]);
var inst_44881 = inst_44856.length;
var inst_44882 = (inst_44881 > (0));
var state_44896__$1 = state_44896;
if(cljs.core.truth_(inst_44882)){
var statearr_44906_44937 = state_44896__$1;
(statearr_44906_44937[(1)] = (12));

} else {
var statearr_44907_44938 = state_44896__$1;
(statearr_44907_44938[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (3))){
var inst_44894 = (state_44896[(2)]);
var state_44896__$1 = state_44896;
return cljs.core.async.impl.ioc_helpers.return_chan(state_44896__$1,inst_44894);
} else {
if((state_val_44897 === (12))){
var inst_44856 = (state_44896[(7)]);
var inst_44884 = cljs.core.vec(inst_44856);
var state_44896__$1 = state_44896;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44896__$1,(15),out,inst_44884);
} else {
if((state_val_44897 === (2))){
var state_44896__$1 = state_44896;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_44896__$1,(4),ch);
} else {
if((state_val_44897 === (11))){
var inst_44860 = (state_44896[(9)]);
var inst_44864 = (state_44896[(10)]);
var inst_44874 = (state_44896[(2)]);
var inst_44875 = [];
var inst_44876 = inst_44875.push(inst_44860);
var inst_44856 = inst_44875;
var inst_44857 = inst_44864;
var state_44896__$1 = (function (){var statearr_44908 = state_44896;
(statearr_44908[(11)] = inst_44876);

(statearr_44908[(7)] = inst_44856);

(statearr_44908[(12)] = inst_44874);

(statearr_44908[(8)] = inst_44857);

return statearr_44908;
})();
var statearr_44909_44939 = state_44896__$1;
(statearr_44909_44939[(2)] = null);

(statearr_44909_44939[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (9))){
var inst_44856 = (state_44896[(7)]);
var inst_44872 = cljs.core.vec(inst_44856);
var state_44896__$1 = state_44896;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_44896__$1,(11),out,inst_44872);
} else {
if((state_val_44897 === (5))){
var inst_44860 = (state_44896[(9)]);
var inst_44864 = (state_44896[(10)]);
var inst_44857 = (state_44896[(8)]);
var inst_44864__$1 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_44860) : f.call(null,inst_44860));
var inst_44865 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_44864__$1,inst_44857);
var inst_44866 = cljs.core.keyword_identical_QMARK_(inst_44857,cljs.core.cst$kw$cljs$core$async_SLASH_nothing);
var inst_44867 = (inst_44865) || (inst_44866);
var state_44896__$1 = (function (){var statearr_44910 = state_44896;
(statearr_44910[(10)] = inst_44864__$1);

return statearr_44910;
})();
if(cljs.core.truth_(inst_44867)){
var statearr_44911_44940 = state_44896__$1;
(statearr_44911_44940[(1)] = (8));

} else {
var statearr_44912_44941 = state_44896__$1;
(statearr_44912_44941[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (14))){
var inst_44889 = (state_44896[(2)]);
var inst_44890 = cljs.core.async.close_BANG_(out);
var state_44896__$1 = (function (){var statearr_44914 = state_44896;
(statearr_44914[(13)] = inst_44889);

return statearr_44914;
})();
var statearr_44915_44942 = state_44896__$1;
(statearr_44915_44942[(2)] = inst_44890);

(statearr_44915_44942[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (10))){
var inst_44879 = (state_44896[(2)]);
var state_44896__$1 = state_44896;
var statearr_44916_44943 = state_44896__$1;
(statearr_44916_44943[(2)] = inst_44879);

(statearr_44916_44943[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_44897 === (8))){
var inst_44856 = (state_44896[(7)]);
var inst_44860 = (state_44896[(9)]);
var inst_44864 = (state_44896[(10)]);
var inst_44869 = inst_44856.push(inst_44860);
var tmp44913 = inst_44856;
var inst_44856__$1 = tmp44913;
var inst_44857 = inst_44864;
var state_44896__$1 = (function (){var statearr_44917 = state_44896;
(statearr_44917[(7)] = inst_44856__$1);

(statearr_44917[(14)] = inst_44869);

(statearr_44917[(8)] = inst_44857);

return statearr_44917;
})();
var statearr_44918_44944 = state_44896__$1;
(statearr_44918_44944[(2)] = null);

(statearr_44918_44944[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__42110__auto___44930,out))
;
return ((function (switch__41984__auto__,c__42110__auto___44930,out){
return (function() {
var cljs$core$async$state_machine__41985__auto__ = null;
var cljs$core$async$state_machine__41985__auto____0 = (function (){
var statearr_44922 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_44922[(0)] = cljs$core$async$state_machine__41985__auto__);

(statearr_44922[(1)] = (1));

return statearr_44922;
});
var cljs$core$async$state_machine__41985__auto____1 = (function (state_44896){
while(true){
var ret_value__41986__auto__ = (function (){try{while(true){
var result__41987__auto__ = switch__41984__auto__(state_44896);
if(cljs.core.keyword_identical_QMARK_(result__41987__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__41987__auto__;
}
break;
}
}catch (e44923){if((e44923 instanceof Object)){
var ex__41988__auto__ = e44923;
var statearr_44924_44945 = state_44896;
(statearr_44924_44945[(5)] = ex__41988__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_44896);

return cljs.core.cst$kw$recur;
} else {
throw e44923;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__41986__auto__,cljs.core.cst$kw$recur)){
var G__44946 = state_44896;
state_44896 = G__44946;
continue;
} else {
return ret_value__41986__auto__;
}
break;
}
});
cljs$core$async$state_machine__41985__auto__ = function(state_44896){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__41985__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__41985__auto____1.call(this,state_44896);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__41985__auto____0;
cljs$core$async$state_machine__41985__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__41985__auto____1;
return cljs$core$async$state_machine__41985__auto__;
})()
;})(switch__41984__auto__,c__42110__auto___44930,out))
})();
var state__42112__auto__ = (function (){var statearr_44925 = (f__42111__auto__.cljs$core$IFn$_invoke$arity$0 ? f__42111__auto__.cljs$core$IFn$_invoke$arity$0() : f__42111__auto__.call(null));
(statearr_44925[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__42110__auto___44930);

return statearr_44925;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__42112__auto__);
});})(c__42110__auto___44930,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

